// EArrayPtr.h: interface for the EArrayPtr class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EARRAYPTR_H__F247C3B3_9454_11D2_AF24_AA0DE873AB61__INCLUDED_)
#define AFX_EARRAYPTR_H__F247C3B3_9454_11D2_AF24_AA0DE873AB61__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/* History:
 * 15/12/1998: - Class creation
 */

/* To do:
 * - Use a allocator class similar to the one of STL.
 *   -> do this at the same time as implementing EArrayObj.
 */

#include "EArray.hpp"

template<class Item>
class EArrayPtr : public EArray<Item *> 
{
public:
  /*! Constructs a array of pointer.
   */
  EArrayPtr() {}

  /*! Destructs all items of the array.
   *
   * The operator \c delete is applied on each item of the array.
   */
	virtual ~EArrayPtr();


};



template<class Item>
EArrayPtr<Item>::~EArrayPtr()
{
  SL nItems = count();
  SL nItem;

  for ( nItem =0; nItem < nItems; ++nItem )
    delete at( nItem );
}

#endif // !defined(AFX_EARRAYPTR_H__F247C3B3_9454_11D2_AF24_AA0DE873AB61__INCLUDED_)
