// EBaseCallback.cpp: implementation of the EBaseCallback class.
//
//////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <memory.h>
#include "EToolLibCompilerSettings.h"
#include "EToolLibMacros.h"
#include "EBaseCallback.h"


EBaseCallback::EBaseCallback( void *pObjReceiver,
                              const void *fnMember,
                              size_t nSizeFnMember )
{
  if ( nSizeFnMember )    // store a member function pointer
  {
     EASSERT( nSizeFnMember <= _ETOOLLIB_MAX_PTR_MEMBER_FUNCTION_SIZE );
    _pObjReceiver = pObjReceiver;
    memcpy( _fnMemberCallback, fnMember, nSizeFnMember );
  }
  else
  {
    _pObjReceiver = (void*)fnMember;   // tricks: tested to now if the callback is valid !
    _fnCallback = fnMember; 
  }
}
