// ###########################################################################
// File: ECallback6RT.h
// (c)Copyright 03/1999, Gaia Creation, Baptiste Lepilleur
// ###########################################################################
#if !defined(AFX_ECALLBACK6RT_H__B78AA262_D476_11D2_BD55_0040053AD648__INCLUDED_)
#define AFX_ECALLBACK6RT_H__B78AA262_D476_11D2_BD55_0040053AD648__INCLUDED_


#include "EBaseCallback.h"

/*! 
 * \brief This class provides a callback without parameters and return value.
 */
template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class ReturnType>
class ECallback6RT : protected EBaseCallback
{
public:
  ECallback6RT() {}

  /*! Tests if the callback has been set.
   * @return \c true if the callback has been set, otherwise \c false.
   */
  operator bool() const;

  /*! Calls the callback.
   */
  ReturnType operator ()(TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6) const;


  typedef ReturnType (*ECallerFn)(const EBaseCallback &cb,TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6);

  ECallback6RT( ECallerFn fnCaller,
             void *pObjReceiver,
             const void *fnMember,
             size_t nSizeFnMember );

private:
  ECallerFn _fnCaller;
};



template< class Function,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class ReturnType >
class ECallbackCallerFn6RT : public ECallback6RT<TP1,TP2,TP3,TP4,TP5,TP6,ReturnType>
{
public:
  ECallbackCallerFn6RT( Function fnCallback );

  static ReturnType caller( const EBaseCallback &cb,TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6 );
};

/*! \brief This class provides a Prototype for static method callback.
 */
template<class ReturnType,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6
         ,class RTpFn,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn,class TP6Fn>
inline ECallbackCallerFn6RT< RTpFn (*)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn)
                                   ,TP1,TP2,TP3,TP4,TP5,TP6,ReturnType >
eCbCreator( ECallback6RT<TP1,TP2,TP3,TP4,TP5,TP6,ReturnType> *, 
                         RTpFn (*fn)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn) )
{
  return ECallbackCallerFn6RT< RTpFn (*)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn)
                            ,TP1,TP2,TP3,TP4,TP5,TP6,ReturnType>( fn );
}

template< class Receiver, class Member,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class ReturnType>
class ECallbackCallerMember6RT : public ECallback6RT<TP1,TP2,TP3,TP4,TP5,TP6,ReturnType>
{
public:
  ECallbackCallerMember6RT( Receiver *pObjReceiver, 
                                  const Member &fnMember );


  static ReturnType caller( const EBaseCallback &cb,TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6 );
};


template< class Receiver, class CallObjType
,class RTpFn,class TP1Fn,class TP2Fn,class TP3Fn,class TP4Fn,class TP5Fn,class TP6Fn
,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class ReturnType >
inline ECallbackCallerMember6RT< Receiver, 
                                       RTpFn (CallObjType::*)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn)
                                       ,TP1,TP2,TP3,TP4,TP5,TP6,ReturnType >
eCbCreator( ECallback6RT<TP1,TP2,TP3,TP4,TP5,TP6,ReturnType> *,
            Receiver &objReceiver,
            RTpFn (CallObjType::* const &fnMemberCallback)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn) )
{
  typedef RTpFn (CallObjType::*MemberCallback)(TP1Fn,TP2Fn,TP3Fn,TP4Fn,TP5Fn,TP6Fn);

  return ECallbackCallerMember6RT< Receiver, MemberCallback
                                ,TP1,TP2,TP3,TP4,TP5,TP6,ReturnType>( &objReceiver,
                                                            fnMemberCallback );
}






// ###################################################################
// Inline methods:
// ###################################################################


template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class ReturnType>
inline 
ECallback6RT<TP1,TP2,TP3,TP4,TP5,TP6,ReturnType>::operator bool() const
{
  return isValid();
}


template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class ReturnType>
inline 
ReturnType
ECallback6RT<TP1,TP2,TP3,TP4,TP5,TP6,ReturnType>::operator ()(TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6) const
{
  return _fnCaller( *this,p1,p2,p3,p4,p5,p6 );
}


template<class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class ReturnType>
inline
ECallback6RT<TP1,TP2,TP3,TP4,TP5,TP6,ReturnType>::ECallback6RT( ECallerFn fnCaller,
                      void *pObjReceiver,
                      const void *fnMember,
                      size_t nSizeFnMember ) :
    EBaseCallback( pObjReceiver,
                   fnMember,
                   nSizeFnMember ),
    _fnCaller( fnCaller )
{
}


template< class Function,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class ReturnType >
inline
ECallbackCallerFn6RT< Function,TP1,TP2,TP3,TP4,TP5,TP6,ReturnType >::ECallbackCallerFn6RT( Function fnCallback ) :
    ECallback6RT<TP1,TP2,TP3,TP4,TP5,TP6,ReturnType>( caller, NULL, fnCallback, 0 )
{
}


template< class Function,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class ReturnType >
inline ReturnType
ECallbackCallerFn6RT< Function,TP1,TP2,TP3,TP4,TP5,TP6,ReturnType >::caller( const EBaseCallback &cb,TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6 )
{
  return ((Function)cb._fnCallback)(p1,p2,p3,p4,p5,p6);
}


template< class Receiver, class Member,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class ReturnType >
inline 
ECallbackCallerMember6RT<Receiver,Member,TP1,TP2,TP3,TP4,TP5,TP6,ReturnType>::ECallbackCallerMember6RT( Receiver *pObjReceiver, 
                                                               const Member &fnMember ) :
    ECallback6RT<TP1,TP2,TP3,TP4,TP5,TP6,ReturnType>( caller, pObjReceiver, &fnMember, sizeof( fnMember ) )
{
}

template< class Receiver, class Member,class TP1,class TP2,class TP3,class TP4,class TP5,class TP6,class ReturnType >
inline ReturnType
ECallbackCallerMember6RT<Receiver,Member,TP1,TP2,TP3,TP4,TP5,TP6,ReturnType>::caller( const EBaseCallback &cb,TP1 p1,TP2 p2,TP3 p3,TP4 p4,TP5 p5,TP6 p6 )
{
  Receiver &objReceiver = *(Receiver *)cb._pObjReceiver;
  Member &fnMember = *(Member *)(void *)cb._fnMemberCallback;

  return (objReceiver.*fnMember)(p1,p2,p3,p4,p5,p6);
}

#endif // !defined(AFX_ECALLBACK6RT_H__B78AA262_D476_11D2_BD55_0040053AD648__INCLUDED_)
