// EHashSetT.h: interface for the EHashSetT class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EHASHSETT_H__992AFCE8_3D03_11D3_BE1D_0040053AD648__INCLUDED_)
#define AFX_EHASHSETT_H__992AFCE8_3D03_11D3_BE1D_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "EHashSetAssoCleanerT.h"
#include "EHashKeyProviderT.h"
#include "EStringKeyProviderT.h"


#include "EBaseHashSetT.h"

// Constantes:
// #####################Last change: 27/03/98 21h49mn#########################


// Macros:
// #####################Last change: 27/03/98 21h49mn#########################


// Types:
// #####################Last change: 27/03/98 21h49mn#########################

template<class Key, class KeyArg, 
         class KeyProvider=EHashKeyProviderCastT<KeyArg>, 
         class Cleaner =EHashSetAssoCleanerT<Key> >
class EHashSetT : public EBaseHashSetT<Key,KeyArg>
{
#ifdef _SUPPORT_TEMPLATE_FRIEND
  friend class EHashSetIteratorT<Key,KeyArg,KeyProvider,Cleaner>;
#endif

public:
  /*! Constructor.
   * @param nSize initial size of the table.
   */
  EHashSetT( SL nSize = 3 );

  /*! Destructor
   */
  virtual ~EHashSetT() {}

protected:
  virtual UL doGetKey( KeyArg key ) const;
  virtual bool doCompareKey( KeyArg key1, KeyArg key2 ) const;
  virtual void doFreeAsso( Key &key );

private:
  KeyProvider _keyProvider;
  Cleaner _cleaner;
};


// Template Implementation:
// #####################Last change: 27/03/98 21h49mn#########################


template<class Key, class KeyArg, class KeyProvider, class Cleaner >
inline 
EHashSetT<Key,KeyArg,KeyProvider,Cleaner>::EHashSetT( SL nSize ) :
    EBaseHashSetT<Key,KeyArg>( nSize )
{
}


template<class Key, class KeyArg, class KeyProvider, class Cleaner >
inline UL 
EHashSetT<Key,KeyArg,KeyProvider,Cleaner>::doGetKey( KeyArg key ) const
{
  return _keyProvider.getKey( key );
}


template<class Key, class KeyArg, class KeyProvider, class Cleaner >
inline bool 
EHashSetT<Key,KeyArg,KeyProvider,Cleaner>::doCompareKey( KeyArg key1, KeyArg key2 ) const
{
  return _keyProvider.compareKey( key1, key2 );
}


template<class Key, class KeyArg, class KeyProvider, class Cleaner >
inline void 
EHashSetT<Key,KeyArg,KeyProvider,Cleaner>::doFreeAsso( Key &key )
{
  _cleaner.freeAsso( key );
}






#endif // !defined(AFX_EHASHSETT_H__992AFCE8_3D03_11D3_BE1D_0040053AD648__INCLUDED_)
