// EHashT.h: interface for the EHashT class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EHASHT_H__34E84051_E109_11D2_9222_004005446EE6__INCLUDED_)
#define AFX_EHASHT_H__34E84051_E109_11D2_9222_004005446EE6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "EHashAssoCleanerT.h"
#include "EHashKeyProviderT.h"
#include "EStringKeyProviderT.h"


#include "EBaseHashT.h"

// Constantes:
// #####################Last change: 27/03/98 21h49mn#########################


// Macros:
// #####################Last change: 27/03/98 21h49mn#########################


// Types:
// #####################Last change: 27/03/98 21h49mn#########################

template<class Key, class Item, class KeyArg, class ItemArg, 
         class KeyProvider=EHashKeyProviderCastT<KeyArg>, class Cleaner =EHashAssoCleanerT<Key, Item> >
class EHashT : public EBaseHashT<Key,Item,KeyArg,ItemArg>
{
#ifdef _SUPPORT_TEMPLATE_FRIEND
  friend class EHashIteratorT<Key,Item,KeyArg,ItemArg,KeyProvider,Cleaner>;
#endif

public:
  /*! Constructor.
   * @param nSize initial size of the table.
   */
  EHashT( SL nSize = 3 );

  /*! Destructor
   */
  virtual ~EHashT() {}

protected:
  virtual UL doGetKey( KeyArg key ) const;
  virtual bool doCompareKey( KeyArg key1, KeyArg key2 ) const;
  virtual void doFreeAsso( Key &key, Item &item );

private:
  KeyProvider _keyProvider;
  Cleaner _cleaner;
};


// Template Implementation:
// #####################Last change: 27/03/98 21h49mn#########################


template<class Key, class Item, class KeyArg, class ItemArg, class KeyProvider, class Cleaner >
inline 
EHashT<Key,Item,KeyArg,ItemArg,KeyProvider,Cleaner>::EHashT( SL nSize ) :
    EBaseHashT<Key,Item,KeyArg,ItemArg>( nSize )
{
}


template<class Key, class Item, class KeyArg, class ItemArg, class KeyProvider, class Cleaner >
inline UL 
EHashT<Key,Item,KeyArg,ItemArg,KeyProvider,Cleaner>::doGetKey( KeyArg key ) const
{
  return _keyProvider.getKey( key );
}


template<class Key, class Item, class KeyArg, class ItemArg, class KeyProvider, class Cleaner >
inline bool 
EHashT<Key,Item,KeyArg,ItemArg,KeyProvider,Cleaner>::doCompareKey( KeyArg key1, KeyArg key2 ) const
{
  return _keyProvider.compareKey( key1, key2 );
}


template<class Key, class Item, class KeyArg, class ItemArg, class KeyProvider, class Cleaner >
inline void 
EHashT<Key,Item,KeyArg,ItemArg,KeyProvider,Cleaner>::doFreeAsso( Key &key, Item &item )
{
  _cleaner.freeAsso( key, item );
}





#endif // !defined(AFX_EHASHT_H__34E84051_E109_11D2_9222_004005446EE6__INCLUDED_)
