// EStoreObjectWriter.cpp: implementation of the EStoreObjectWriter class.
//
//////////////////////////////////////////////////////////////////////

#include "usuel.hpp"
#include "EDataStr.hpp"
#include "EString.hpp"
#include "EStoreOtWriter.h"
#include "EStoreOtReaderContext.h"
#include "EStoreOtDef.h"
#include "EStoreOtPrp.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

EStoreOtWriter::EStoreOtWriter() :
    _nObjectLevel( 0 ),
    _pstreamOut( NULL )
{

}

EStoreOtWriter::~EStoreOtWriter()
{

}


void 
EStoreOtWriter::finish()
{
  EASSERT( _nObjectLevel == 0 );      // Some object have not been closed !!!
}


void 
EStoreOtWriter::buildObject( EStoreObjectType esotpObject )
{
  EString strLine;
  addIndent( strLine );
  strLine += _T( '(' );
  strLine += def().objectTypeName( esotpObject );
  pushLine( strLine );
  ++_nObjectLevel;
}


void 
EStoreOtWriter::buildObjectClose()
{
  --_nObjectLevel;
  EASSERT( _nObjectLevel >= 0 );      // No matching object created !!!
  EString strLine;
  addIndent( strLine );
  strLine += _T( ')' );
  pushLine( strLine );
}


void 
EStoreOtWriter::buildProperty( EStoreOtPrp &prp )
{
  EString strLine;
  addIndent( strLine );
  strLine += def().prpTypeName( prp.prpType() );
  strLine += _T( " = " );
  strLine += prp.encodedPrp();
  pushLine( strLine );
}


void 
EStoreOtWriter::pushLine( const EString &strLine )
{
  EASSERT( _pstreamOut );
  const char *cszNl = "\r\n";
  EAString astrLine = strLine;
  _pstreamOut->writeBlock( astrLine.datas(), 
                           astrLine.length() );
  _pstreamOut->writeBlock( cszNl, 
                           strlen( cszNl ) );
}
