// ###########################################################################
// File: ELOG.CPP
// (c)Copyright 10/1997, Lepilleur Baptiste (Aka Elyon from Zuul Design)
// version 0.0
// ###########################################################################

#include <stdio.h>
#include "usuel.hpp"
#include "elog.hpp"

ELog slog;



void ELog::init()
{
  mFile =0;
  mFileStderr =0;
  setDevice( &mMultiDev );
}

ELog::ELog()
{
  init();
}

ELog::ELog( const char *file )
{
  init();
  setFilename( file );
}

ELog::~ELog()
{
  close();
  mMultiDev.removeDevice( mFile );
  mMultiDev.removeDevice( mFileStderr );
  delete mFile;
  delete mFileStderr;
}


void ELog::setFilename( const char *file )
{
  mMultiDev.removeDevice( mFile );
  if ( file )
  {
    mFile = new EFile( file );
    mFile->open( EIO_WriteOnly );
    mMultiDev.addDevice( mFile );
  }
}

void ELog::close()
{
  mMultiDev.close();
}

void ELog::flush()
{
  mMultiDev.flush();
}

void ELog::useStdErr( bool activ )
{
  if ( activ  &&  !mFileStderr )
  {
    mFileStderr = new EFileStd( stderr );
    mFileStderr->open( EIO_WriteOnly );
    mMultiDev.addDevice( mFileStderr );
  }
  else
    if ( !activ  && mFileStderr )
    {
      mMultiDev.removeDevice( mFileStderr );
      delete mFileStderr;
      mFileStderr =0;
    }
}


// ############################# EOF ELOG.CPP ################################
// ############################# EOF ELOG.CPP ################################
// ############################# EOF ELOG.CPP ################################

