// TfwkDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TfwkUi.h"
#include "TfwkDlg.h"
#include "Tfwk.h"
#include "TfwkUiCfg.h"
#include "TfwkUiCfgReader.h"
#include "TfwkUiCfgWriter.h"
#include "TfwkUiCfgBuilderTree.h"
#include "TfwkUiTest.h"
#include "TfwkUiSuite.h"
#include "TfwkUiCfgTestIt.h"
#include "TfwkUiDlgNewSuite.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define REG_SECTION "TfwkUi"
#define REG_ENTRY_LASTFILE "LastFile"


/////////////////////////////////////////////////////////////////////////////
// CAboutTfwkUiDlg dialog used for App About

class CAboutTfwkUiDlg : public CDialog
{
public:
	CAboutTfwkUiDlg();

// Dialog Data
	//{{AFX_DATA(CAboutTfwkUiDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutTfwkUiDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutTfwkUiDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutTfwkUiDlg::CAboutTfwkUiDlg() : CDialog(CAboutTfwkUiDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutTfwkUiDlg)
	//}}AFX_DATA_INIT
}

void CAboutTfwkUiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutTfwkUiDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutTfwkUiDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutTfwkUiDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// TfwkDlg dialog

TfwkDlg::TfwkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(TfwkDlg::IDD, pParent)
{
  _pParentWnd = pParent;

	//{{AFX_DATA_INIT(TfwkDlg)
	_strFailure = _T("");
	_strError = _T("");
	_strSuccess = _T("");
	_strTotal = _T("");
	_strSkipped = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

  _pConfig = new TfwkUiCfg;
  SetChange( false );
}


BOOL
TfwkDlg::Create()
{
  return CDialog::Create( IDD, _pParentWnd );
}


TfwkDlg::~TfwkDlg()
{
  if ( _pConfig )
    delete _pConfig;
}


void TfwkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(TfwkDlg)
	DDX_Control(pDX, IDC_TFWKUI_LIST_RESULT, _lvResult);
	DDX_Control(pDX, IDC_TFWKUI_TREE_SUITE, _treeSuite);
	DDX_Control(pDX, IDC_TFWKUI_LIST_UNITTEST, _lbUnitTest);
	DDX_Text(pDX, IDC_TFWKUI_STATIC_FAILURE, _strFailure);
	DDX_Text(pDX, IDC_TFWKUI_STATIC_ERROR, _strError);
	DDX_Text(pDX, IDC_TFWKUI_STATIC_SUCESS, _strSuccess);
	DDX_Text(pDX, IDC_TFWKUI_STATIC_TOTAL, _strTotal);
	DDX_Text(pDX, IDC_TFWKUI_STATIC_SKIPPED, _strSkipped);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(TfwkDlg, CDialog)
	//{{AFX_MSG_MAP(TfwkDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_TFWKUI_NEW, OnTfwkuiNew)
	ON_COMMAND(ID_TFWKUI_OPEN, OnTfwkuiOpen)
	ON_COMMAND(ID_TFWKUI_SAVE, OnTfwkuiSave)
	ON_COMMAND(ID_TFWKUI_QUIT, OnTfwkuiQuit)
	ON_COMMAND(ID_TFWKUI_ABOUT, OnTfwkuiAbout)
	ON_COMMAND(ID_TFWKUI_HELP, OnTfwkuiHelp)
	ON_COMMAND(ID_TFWKUI_TREESUITE_NEW_SUITE, OnTfwkuiTreeSuiteNewSuite)
	ON_COMMAND(ID_TFWKUI_TREESUITE_DELETE_SUITE, OnTfwkuiTreeSuiteDeleteSuite)
	ON_COMMAND(ID_TFWKUI_TREESUITE_ADD_TEST, OnTfwkuiTreeSuiteAddTest)
	ON_COMMAND(ID_TFWKUI_TREESUITE_REMOVE_TEST, OnTfwkuiTreeSuiteRemoveTest)
	ON_UPDATE_COMMAND_UI(ID_TFWKUI_UNITTEST_SHOW_ONLY_UNUSED, OnUpdateTfwkuiUnittestShowOnlyUnused)
	ON_COMMAND(ID_TFWKUI_UNITTEST_SHOW_ONLY_UNUSED, OnTfwkuiUnittestShowOnlyUnused)
	ON_BN_CLICKED(IDC_TFWKUI_TREESUITE_ADD_TEST, OnTfwkuiTreeSuiteAddTest)
	ON_COMMAND(ID_TFWKUI_TREESUITE_EDIT_SUITE, OnTfwkuiTreeSuiteEditSuite)
	ON_COMMAND(ID_TFWKUI_TREESUITE_RUN_SUITE, OnTfwkuiTreeSuiteRunSuite)
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// TfwkDlg message handlers

BOOL TfwkDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_TFWKUI_ABOUTBOX must be in the system command range.
	ASSERT((IDM_TFWKUI_ABOUTBOX & 0xFFF0) == IDM_TFWKUI_ABOUTBOX );
	ASSERT(IDM_TFWKUI_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString( IDS_TFWKUI_ABOUT );
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_TFWKUI_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
  m_hAccelerator = ::LoadAccelerators( AfxGetResourceHandle(),
                                       MAKEINTRESOURCE( IDR_TFWKUI_DLG_MAIN ) );
	
  SetupReportList();
  UpdateUi();

  // Load last saved test file
  CString strFilename = getLastSavedFilename();
  if ( !strFilename.IsEmpty() )
    loadTestSuite( strFilename, true );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void TfwkDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_TFWKUI_ABOUTBOX )
	{
    OnTfwkuiAbout();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void TfwkDlg::OnDestroy()
{
  ListenerArray::TfwkIt it( _apListener );
  for ( it.begin(); !it.isEnd(); it.next() )
    it.item()->windowClosed();
  
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void TfwkDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR TfwkDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void 
TfwkDlg::GetTestList()
{
  const TfwkUnitTestInfo *pUnitTest = TfwkUnitTestInfo::firstUnitTest();

  CString strTestName;
  CString strMethodName;

  for ( ; pUnitTest; pUnitTest = pUnitTest->nextUnitTest() )
  {
    strTestName = pUnitTest->nameTest();
    const TfwkClassId &clsidTest = pUnitTest->clsidTest();

    TfwkMethodInfoIt itMethod = pUnitTest->itMethod();
    for ( itMethod.begin(); !itMethod.isEnd(); itMethod.next() )
    {
      const TfwkUnitTestMethodInfo *pMethodInfo = itMethod.item();
      strMethodName = pMethodInfo->name();

      strMethodName.Format( "%s::%s", 
                            (const char *)strTestName, 
                            pMethodInfo->name() );

      _lbUnitTest.AddString( strMethodName );

//      TfwkUnitTest *pTest = (TfwkUnitTest *)clsidTest.createObject();
//      pMethodInfo->run( pTest );
//      delete pTest;
    }
  }
}


void 
TfwkDlg::OnTfwkuiNew() 
{
  cfg().RootSuite().Clear();
  UpdateUi();
}


void 
TfwkDlg::OnTfwkuiOpen() 
{
  CFileDialog dlg( TRUE, 
                   _T( "tsu" ),
                   _T( "TestSuite" ),
                   OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
                   _T( "Test Suite Files (*.tsu)|*.tsu|Text Files (*.txt|*.ini)|*.txt;*.ini|All Files (*.*)|*.*||" )
                   );
  if ( dlg.DoModal() == IDOK )
  {
    CString strFilename = dlg.GetPathName();
    loadTestSuite( strFilename );
  }
}


void 
TfwkDlg::OnTfwkuiSave() 
{
  CFileDialog dlg( FALSE, 
                   _T( "tsu" ),
                   _T( "TestSuite" ),
                   OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
                   _T( "Test Suite Files (*.tsu)|*.tsu|Text Files (*.txt|*.ini)|*.txt;*.ini|All Files (*.*)|*.*||" )
                   );
  if ( dlg.DoModal() == IDOK )
  {
    CString strFilename = dlg.GetPathName();
    TRY
    {
      CFile file( strFilename, CFile::modeCreate | CFile::modeWrite );
      TfwkUiCfgWriter writer( file, *_pConfig );

      writer.Save();

      AfxGetApp()->WriteProfileString( REG_SECTION, REG_ENTRY_LASTFILE, strFilename );
    }
    CATCH( CException, pException )
    {
      AfxMessageBox( IDS_TFWKUI_CFG_ERROR_WRITING );
    }
    END_CATCH
  }
}


void 
TfwkDlg::OnTfwkuiQuit() 
{
  if ( IsChanged() )
  {
    int nChoice;
    nChoice = AfxMessageBox( IDS_TFWKUI_SAVE_CHANGE, MB_YESNOCANCEL );
    if ( nChoice == IDOK )
    {
      OnTfwkuiSave();
    }
    else if ( nChoice == IDCANCEL )
      return;
  }

  DestroyWindow();
}


void 
TfwkDlg::OnTfwkuiAbout() 
{
	CAboutTfwkUiDlg dlgAbout;
	dlgAbout.DoModal();
}


void 
TfwkDlg::OnTfwkuiHelp() 
{
}


void 
TfwkDlg::UpdateUi()
{
  UpdateListUnitTest();
  _treeSuite.RebuildTree( cfg().RootSuite() );
}


void 
TfwkDlg::UpdateListUnitTest()
{
  CListBox &lbTest = _lbUnitTest;
  bool bUnusedOnly = cfg().IsShowOnlyUnused();

  lbTest.ResetContent();

  TfwkUiCfgTestIt itTest;
  cfg().ItTest( itTest, bUnusedOnly );
  CString strTestName;
  for ( itTest.Begin(); !itTest.IsEnd(); itTest.Next() )
  {
    TfwkUiTestCfg &test = itTest.Item();
    test.FullMethodName( strTestName );
    int nIndex = lbTest.AddString( strTestName );
    if ( nIndex >= 0)
    {
      if ( lbTest.SetItemDataPtr( nIndex, &test ) == LB_ERR )
        lbTest.DeleteString( nIndex );
    }
  }
}


void 
TfwkDlg::OnTfwkuiTreeSuiteNewSuite()
{
  HTREEITEM hItem = _treeSuite.GetSelectedItem();
  TfwkUiSuite *pParentSuite = &cfg().RootSuite();
  if ( hItem )
  {
    TfwkUiTreeSuiteItem *pItem = (TfwkUiTreeSuiteItem *)_treeSuite.GetItemData( hItem );
    if ( pItem->IsSuite() )
      pParentSuite = (TfwkUiSuite *)pItem;
    else if ( pItem->IsTest() )
      pParentSuite = &((TfwkUiTest *)pItem)->ParentSuite();
  }

  CString strName;
  VERIFY( strName.LoadString( IDS_TFWKUI_DEFAULT_SUITENAME ) );
  
  TfwkUiSuite *pSuite = new TfwkUiSuite(pParentSuite, strName );
  TfwkUiDlgNewSuite dlg( pSuite );
  if ( dlg.DoModal() == IDOK )
  {
    HTREEITEM hParentItem = _treeSuite.AddSuite( pParentSuite, hItem, pSuite );
    _treeSuite.Expand( hParentItem, TVE_EXPAND );
  }
  else
  {
    pParentSuite->RemoveSuite( pSuite );
  }

}


void 
TfwkDlg::OnTfwkuiTreeSuiteDeleteSuite()
{
  HTREEITEM hItem = _treeSuite.GetSelectedItem();
  if ( hItem )
  {
    TfwkUiTreeSuiteItem *pItem = (TfwkUiTreeSuiteItem *)_treeSuite.GetItemData( hItem );
    if ( pItem->IsSuite() )
    {
      TfwkUiSuite *pSuite = (TfwkUiSuite *)pItem;
      if ( pSuite->ParentSuite() )
      {
        _treeSuite.DeleteSuite( hItem );
        pSuite->ParentSuite()->RemoveSuite( pSuite );
      }
    }
  }
}


void 
TfwkDlg::OnTfwkuiTreeSuiteAddTest()
{
  HTREEITEM hItem = _treeSuite.GetSelectedItem();
  if ( !hItem )
    return;

  // Parent Item
  hItem = _treeSuite.GetParentSuite( hItem );
  
  // Parent suite
  TfwkUiSuite *pSuite = NULL;    // parent suite
  if ( hItem )
  {
    pSuite = (TfwkUiSuite *)_treeSuite.GetItemData( hItem );
  }
  if ( !pSuite )
    pSuite = &cfg().RootSuite();

  // Selections
  CListBox &lb = _lbUnitTest;
  int nSelCount = lb.GetSelCount();
  if ( nSelCount <= 0 )
    return;

  int *pSel = new int[ nSelCount ];
  nSelCount = lb.GetSelItems( nSelCount, pSel );
  if ( nSelCount > 0)
  {
    int nPos;
    for ( nPos =0; nPos < nSelCount; ++nPos )
    {
      // Each selection
      int nIndex = pSel[ nPos ];
      TfwkUiTestCfg *pTest = (TfwkUiTestCfg *)lb.GetItemDataPtr( nIndex );
      if ( pTest )
      {
        TfwkUiTest *pUiTest = new TfwkUiTest( pSuite,
                                              pTest->Class(),
                                              pTest->Method(),
                                              1234,
                                              pTest );
        _treeSuite.AddTest( hItem, pUiTest );
      }
    }

    _treeSuite.Expand( hItem, TVE_EXPAND );
    _treeSuite.SortChildren( hItem );
  }

  if ( pSel )
    delete pSel;
}


void 
TfwkDlg::OnTfwkuiTreeSuiteRemoveTest()
{
}


BOOL 
TfwkDlg::PreTranslateMessage(MSG* pMsg) 
{
  if ( m_hAccelerator )
  {
    if ( ::TranslateAccelerator( m_hWnd,
                                 m_hAccelerator,
                                 pMsg ) )
    {
      return TRUE;
    }
  }
  return CDialog::PreTranslateMessage(pMsg);
}



void 
TfwkDlg::OnUpdateTfwkuiUnittestShowOnlyUnused(CCmdUI* pCmdUI) 
{
  pCmdUI->SetCheck( cfg().IsShowOnlyUnused() ? 1 : 0 );
}


void 
TfwkDlg::OnTfwkuiUnittestShowOnlyUnused() 
{
  cfg().SetShowOnlyUnused( !cfg().IsShowOnlyUnused() );
  UpdateListUnitTest();
}


void 
TfwkDlg::OnTfwkuiTreeSuiteEditSuite()
{
  HTREEITEM hItem = _treeSuite.GetSelectedItem();
  if ( !hItem )
    return;
  TfwkUiTreeSuiteItem *pItem = (TfwkUiTreeSuiteItem *)_treeSuite.GetItemData( hItem );
  if ( !pItem  || 
       !pItem->IsSuite() )
  {
    return;
  }

  TfwkUiSuite *pSuite = (TfwkUiSuite *)pItem;
  TfwkUiDlgNewSuite dlg( pSuite );
  if ( dlg.DoModal() == IDOK )
  {
    _treeSuite.UpdateSubTree( hItem, pSuite );
    _treeSuite.UpdateWindow();
  }
}


void 
TfwkDlg::OnTfwkuiTreeSuiteRunSuite()
{
  HTREEITEM hItem = _treeSuite.GetSelectedItem();
  if ( !hItem )
    return;
  TfwkUiTreeSuiteItem *pItem = (TfwkUiTreeSuiteItem *)_treeSuite.GetItemData( hItem );
  if ( !pItem  || 
       !pItem->IsSuite() )
  {
    return;
  }

  TfwkUiSuite *pSuite = (TfwkUiSuite *)pItem;

  StartLogReportTestSuite();

  pSuite->RunTest( cfg(), _reportTestSuite );

  LogReportTestSuite();
}


void 
TfwkDlg::LogReportTestSuite()
{
  UpdateData();

	_strFailure.Format( IDS_TFWKUI_REPORT_FAILURE,
                      _reportTestSuite._nFailure );
	_strError.Format( IDS_TFWKUI_REPORT_ERROR,
                      _reportTestSuite._nError );
	_strSuccess.Format( IDS_TFWKUI_REPORT_SUCCESS,
                      _reportTestSuite._nSuccess );
	_strTotal.Format( IDS_TFWKUI_REPORT_TOTAL,
                      _reportTestSuite._nTotal );
	_strSkipped.Format( IDS_TFWKUI_REPORT_SKIPPED,
                      _reportTestSuite._nSkipped );
  UpdateData( FALSE );
}


void 
TfwkDlg::SetupReportList()
{
  _imlReport.Create( IDB_TFWKUI_REPORT, 16, 1, RGB( 255,0,255 ) );

  CListCtrl &list = _lvResult;

  list.SetImageList( &_imlReport, LVSIL_NORMAL );
  list.SetImageList( &_imlReport, LVSIL_SMALL );

  LV_COLUMN lvCol;
  lvCol.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
  lvCol.fmt = LVCFMT_LEFT;

  CString str;
  char *s;

  VERIFY( str.LoadString( IDS_TFWKUI_REPORT_SUITE ) );
  s = str.GetBuffer( str.GetLength() );
  lvCol.pszText = s ; 
	lvCol.iSubItem = 0 ;
  lvCol.cx = 100;
	list.InsertColumn( 0, &lvCol ) ;
  str.ReleaseBuffer();

  VERIFY( str.LoadString( IDS_TFWKUI_REPORT_CLASS_METHOD ) );
  s = str.GetBuffer( str.GetLength() );
  lvCol.pszText = s ; 
	lvCol.iSubItem = 1 ;
  lvCol.cx = 280;
	list.InsertColumn( 1, &lvCol ) ;
  str.ReleaseBuffer();

  VERIFY( str.LoadString( IDS_TFWKUI_REPORT_LINE ) );
  s = str.GetBuffer( str.GetLength() );
  lvCol.pszText = s ; 
	lvCol.iSubItem = 2 ;
  lvCol.cx = 40;
	list.InsertColumn( 2, &lvCol ) ;
  str.ReleaseBuffer();

  VERIFY( str.LoadString( IDS_TFWKUI_REPORT_DETAIL ) );
  s = str.GetBuffer( str.GetLength() );
  lvCol.pszText = s ; 
	lvCol.iSubItem = 3 ;
  lvCol.cx = 250;
	list.InsertColumn( 3, &lvCol ) ;
  str.ReleaseBuffer();

  VERIFY( str.LoadString( IDS_TFWKUI_REPORT_SOURCE ) );
  s = str.GetBuffer( str.GetLength() );
  lvCol.pszText = s ; 
	lvCol.iSubItem = 4 ;
  lvCol.cx = 250;
	list.InsertColumn( 4, &lvCol ) ;
  str.ReleaseBuffer();

}


void 
TfwkDlg::StartLogReportTestSuite()
{
  _lvResult.DeleteAllItems();
  _reportTestSuite.Reset();
  _reportTestSuite._pDlg = this;
}


void 
TfwkDlg::ReportError( const TfwkUiReportError &err )
{
  CListCtrl &list = _lvResult;

  if ( !list.GetSafeHwnd() )
    return;

  char *s;
  CString str;
  int nItem = list.GetItemCount();

  LV_ITEM		lvItem ;

  str = err._pTest ? err._pTest->ParentSuite().Name() : "?";
  s = str.GetBuffer( str.GetLength() );
  lvItem.mask = LVIF_TEXT | LVIF_IMAGE;
  lvItem.iItem = nItem; lvItem.iSubItem = 0;
  lvItem.state = 0; lvItem.stateMask = 0;
  lvItem.pszText = s;
  lvItem.lParam = NULL;
  switch  ( err._etpError )
  {
  case etpFailure:  lvItem.iImage = imgAssertion; break;
  default:
  case etpError:  lvItem.iImage = imgException; break;
  }
  nItem = list.InsertItem( &lvItem );
  str.ReleaseBuffer();

  str = err._pTest ? err._pTest->Class() + "::" + err._pTest->Method() :
                     "?";
  s = str.GetBuffer( str.GetLength() );
  lvItem.mask = LVIF_TEXT;
  lvItem.iItem = nItem; lvItem.iSubItem = 1;
  lvItem.state = 0; lvItem.stateMask = 0;
  lvItem.pszText = s;
  lvItem.lParam = NULL;
  list.SetItem( &lvItem );
  str.ReleaseBuffer();

  str.Format( _T( "%d" ), err._nLine );
  s = str.GetBuffer( str.GetLength() );
  lvItem.mask = LVIF_TEXT;
  lvItem.iItem = nItem; lvItem.iSubItem = 2;
  lvItem.state = 0; lvItem.stateMask = 0;
  lvItem.pszText = s;
  lvItem.lParam = NULL;
  list.SetItem( &lvItem );
  str.ReleaseBuffer();

  str = err._strDetail;
  s = str.GetBuffer( str.GetLength() );
  lvItem.mask = LVIF_TEXT;
  lvItem.iItem = nItem; lvItem.iSubItem = 3;
  lvItem.state = 0; lvItem.stateMask = 0;
  lvItem.pszText = s;
  lvItem.lParam = NULL;
  list.SetItem( &lvItem );
  str.ReleaseBuffer();

  str = err._strSource;
  s = str.GetBuffer( str.GetLength() );
  lvItem.mask = LVIF_TEXT;
  lvItem.iItem = nItem; lvItem.iSubItem = 4;
  lvItem.state = 0; lvItem.stateMask = 0;
  lvItem.pszText = s;
  lvItem.lParam = NULL;
  list.SetItem( &lvItem );
  str.ReleaseBuffer();
}


CString 
TfwkDlg::getLastSavedFilename()
{
  return AfxGetApp()->GetProfileString( REG_SECTION, REG_ENTRY_LASTFILE );
}


void 
TfwkDlg::loadTestSuite( const CString &strFilename,
                        bool bSilentError )
{
  TRY
  {
    CFile file( strFilename, CFile::modeRead );
    TfwkUiCfgBuilderTree builder;
    TfwkUiCfgReader reader( file, 
                            builder );
    TfwkUiCfgReader::TokenType tktp = reader.ParseSuiteTree();
    bool bOk = false;
    CString strError;
    if ( tktp == TfwkUiCfgReader::tktpError )
    {
      VERIFY( strError.LoadString( reader.LastError() ) );
    }
    else if ( !builder.IsValid() )
    {
      VERIFY( strError.LoadString( IDS_TFWKUI_CFG_UNMATCHED_SUITE ) );
    }
    else
    {
      bOk = true;
    }


    if ( !bOk )   // errror
    {
      if ( !bSilentError )
      {
        CString strMsg;
        strMsg.Format( IDS_TFWKUI_CFG_ERROR, 
                         reader.Line(),
                         (LPCTSTR)strError );
        AfxMessageBox( strMsg );
      }
    }
    else         // success
    {
      if ( _pConfig )
        delete _pConfig;
      _pConfig = builder.Config();
      SetChange( false );
      UpdateUi();
    }
  }
  CATCH( CException, pException )
  {
    AfxMessageBox( IDS_TFWKUI_CFG_ERROR_READING );
  }
  END_CATCH
}


void 
TfwkDlg::runAllTest()
{
  TfwkUiSuite &suiteRoot = cfg().RootSuite();

  StartLogReportTestSuite();

  suiteRoot.RunTest( cfg(), _reportTestSuite );

  LogReportTestSuite();
}


void 
TfwkDlg::addWindowCloseListener( TfwkDlgCloseListener *pListener )
{
  if ( !pListener )
    return;

  _apListener.add( pListener );
}


void 
TfwkDlg::runSuite( const CString &strName )
{
  TfwkUiSuite *pSuite = cfg().findSuite( strName );
  if ( !pSuite )
    return;

  StartLogReportTestSuite();

  pSuite->RunTest( cfg(), _reportTestSuite );

  LogReportTestSuite();
}
