// TfwkInterfaceInDll.cpp: implementation of the TfwkInterfaceInDll class.
//
//////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include "TfwkCommon.h"
#include "TfwkInterfaceInDll.h"
#include "TfwkUnitTestMethodInfo.h"
#include "TfwkUnitTestInfo.h"
#include "TfwkTestReport.h"
#include "TfwkUnitTest.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TfwkInterfaceInDll::TfwkInterfaceInDll()
{

}

TfwkInterfaceInDll::~TfwkInterfaceInDll()
{

}


void 
TfwkInterfaceInDll::doTest( const TfwkUnitTestMethodInfo &info,
                            TfwkTestReport &report )
{
  TfwkUnitTest *pTest = (TfwkUnitTest *)info.unitTest().clsidTest().createObject();
  if ( pTest )
  {
    preRunTest( info, report, *pTest );
    try
    {
      doRunTest( info, report, *pTest );
      report.testSuccess();
    }
    catch( TfwkExc &exc )
    {
      if ( exc.reason() == TfwkExc::trAssertionFailed )
        report.testAssert( exc.info(), 
                           exc.source(), 
                           exc.line() );
      else
        report.testInternal();
    }
    catch( ... )
    {
      report.testException();
    }
    postRunTest( info, report, *pTest );
    delete pTest;
  }
  else
  {
    report.testInternal();
  }
}


void 
TfwkInterfaceInDll::doRunTest( const TfwkUnitTestMethodInfo &info,
                               TfwkTestReport &report,
                               TfwkUnitTest &test )
{
  info.run( &test );
}


