// TfwkUiCfg.h: interface for the TfwkUiCfg class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TFWKUICFG_H__AC16C643_420D_11D3_BE2C_0040053AD648__INCLUDED_)
#define AFX_TFWKUICFG_H__AC16C643_420D_11D3_BE2C_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TfwkUiSuite.h"
#include "TfwkUiTestCfg.h"
class TfwkUiCfgTestIt;

class TfwkUiCfg  
{
public:
  friend class TfwkUiCfgTestIt;

	TfwkUiCfg();
	virtual ~TfwkUiCfg();

  TfwkUiSuite &RootSuite();
  TfwkUiSuite *findSuite( const CString &strName );

  TfwkUiSuite *findSuite( const CString &strName, TfwkUiSuite *pSuite );

  bool IsShowOnlyUnused() const;
  void SetShowOnlyUnused( bool bUnused =true);
  void ItTest( TfwkUiCfgTestIt &it,
               bool bShowUnused =true );


  TfwkUiTestCfg *FindTest( TfwkUiSourceId idSource,
                           const CString &strFullMethodName );
  
private:
  /** Gets the unit tests from the framework and put them in a map.
   */
  void SetupUnitTestMap();

private:
  typedef CMap<CString,LPCTSTR,TfwkUiTestCfg*,TfwkUiTestCfg*> MapTestCfg;

  TfwkUiSuite _suiteRoot;
  bool _bShowUnused;
  MapTestCfg _mapTestCfg;
};


inline TfwkUiSuite &
TfwkUiCfg::RootSuite()
{
  return _suiteRoot;
}


inline bool 
TfwkUiCfg::IsShowOnlyUnused() const
{
  return _bShowUnused;
}


inline void 
TfwkUiCfg::SetShowOnlyUnused( bool bUnused )
{
  _bShowUnused = bUnused;
}



#endif // !defined(AFX_TFWKUICFG_H__AC16C643_420D_11D3_BE2C_0040053AD648__INCLUDED_)
