// TfwkUiCfgBuilder.h: interface for the TfwkUiCfgBuilder class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TFWKUICFGBUILDER_H__EDB173B4_41EF_11D3_BE2B_0040053AD648__INCLUDED_)
#define AFX_TFWKUICFGBUILDER_H__EDB173B4_41EF_11D3_BE2B_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class TfwkUiCfgBuilder  
{
public:
  TfwkUiCfgBuilder() {}
  virtual ~TfwkUiCfgBuilder() {}

  /*!
   * Builds a suite.
   * @param strName [In] Name of the suite.
   */
  virtual void BuildSuite( const CString &strName ) {}

  /*!
   * Builds a suite termination.
   * @return \c true if a suite was ended, otherwise returns \c false.
   */
  virtual bool BuildEndSuite() { return false; }

  /*!
   * Builds a test.
   * @param strClass [In] Name of the class of the test.
   * @param strMethod [In] Name of the method of the test.
   */
  virtual void BuildTest( const CString &strClass,
                          const CString &strMethod ) {}

};

#endif // !defined(AFX_TFWKUICFGBUILDER_H__EDB173B4_41EF_11D3_BE2B_0040053AD648__INCLUDED_)
