// TfwkUiCfgBuilderTree.cpp: implementation of the TfwkUiCfgBuilderTree class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TfwkUi.h"
#include "TfwkUiCfgBuilderTree.h"
#include "TfwkUiCfg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TfwkUiCfgBuilderTree::TfwkUiCfgBuilderTree() :
    _nSuiteDepth( 0 )
{
  _pConfig = new TfwkUiCfg();
  _pSuite = &_pConfig->RootSuite();
}


TfwkUiCfgBuilderTree::~TfwkUiCfgBuilderTree()
{
  if ( _pConfig )    // The result was never retreived.
    delete _pConfig;
}


void 
TfwkUiCfgBuilderTree::BuildSuite( const CString &strName )
{
  TfwkUiSuite *pSuite = new TfwkUiSuite( _pSuite, strName );
  _pSuite = pSuite;
  ++_nSuiteDepth;
}


bool
TfwkUiCfgBuilderTree::BuildEndSuite()
{
  if ( !_nSuiteDepth-- )
    return false;

  _pSuite = _pSuite->ParentSuite();   // NULL if _pSuite was the root suite!

  return true;
}


void 
TfwkUiCfgBuilderTree::BuildTest( const CString &strClass,
                                 const CString &strMethod )
{
  CString strString;
  strString.Format( "%s::%s", (LPCTSTR)strClass, (LPCTSTR)strMethod );
  TfwkUiTestCfg *pTestCfg = _pConfig->FindTest( 1234, strString );
  TfwkUiTest *pTest = new TfwkUiTest( _pSuite, strClass, strMethod, 1234, pTestCfg );
}


bool 
TfwkUiCfgBuilderTree::IsValid() const
{
  return _nSuiteDepth == 0;
}


TfwkUiCfg *
TfwkUiCfgBuilderTree::Config()
{
  TfwkUiCfg *pConfig = _pConfig;
  _pConfig =NULL;
  return pConfig;
}
