// TfwkUiCfgKey.h: interface for the TfwkUiCfgKey class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TFWKUICFGKEY_H__EDB173B8_41EF_11D3_BE2B_0040053AD648__INCLUDED_)
#define AFX_TFWKUICFGKEY_H__EDB173B8_41EF_11D3_BE2B_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class TfwkUiCfgKey  
{
public:
	TfwkUiCfgKey();
	TfwkUiCfgKey( const CString &strName,
                const CString &strValue );

	virtual ~TfwkUiCfgKey();

  /*!
   * Parses and setup the key.
   * @param strLine [In] String the key is read from. Must be left & right trimed.
   * @return \c true if the key has been successfuly parsed, otherwise returns
   *         \c false.
   */
  bool Parse( const CString &strLine );

  /*!
   * Makes a key string.
   * @param strLine [Out] On return, string that contains the key.
   */
  void Make( CString &strLine );

  /*!
   * Tests if the key name is matching.
   * @param strName [In] The key name is compared to this one.
   * @return \c true if the two name are identical, otherwise returns \c false.
   */
  bool IsName( const CString &strName ) const;

  /*!
   * Gets the value.
   * @return The value.
   */
  const CString &Value() const;

private:
  CString _strName;
  CString _strValue;
};


inline bool 
TfwkUiCfgKey::IsName( const CString &strName ) const
{
  return !strName.CompareNoCase( _strName );
}


inline const CString &
TfwkUiCfgKey::Value() const
{
  return _strValue;
}


inline
TfwkUiCfgKey::TfwkUiCfgKey( const CString &strName,
                            const CString &strValue ) :
    _strName( strName ),
    _strValue( strValue )
{
}


#endif // !defined(AFX_TFWKUICFGKEY_H__EDB173B8_41EF_11D3_BE2B_0040053AD648__INCLUDED_)
