// TfwkUiCfgTestIt.h: interface for the TfwkUiCfgTestIt class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TFWKUICFGTESTIT_H__33520482_4266_11D3_BE2D_0040053AD648__INCLUDED_)
#define AFX_TFWKUICFGTESTIT_H__33520482_4266_11D3_BE2D_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TfwkUiTestCfg.h"
#include "TfwkUiCfg.h"

class TfwkUiCfgTestIt  
{
public:

  TfwkUiCfgTestIt() {}

  /*!
   * Constructs an iterator on the test of a given source.
   * @param cfg [In] Configuration.
   * @param idSource [In] Source id.
   * @param bUnused [In] If \c true then iterates on unsued test only.
   */
	void Attach( TfwkUiCfg &cfg,
               bool bUnused =true );

  /*!
   * Destructor.
   */
  virtual ~TfwkUiCfgTestIt() {}

  /*!
   * Begins iteration.
   */
  void Begin();

  /*!
   * Iterates to the next element.
   */
  void Next();

  /*!
   * Gets the current test.
   * @return Reference on the current test.
   */
  TfwkUiTestCfg &Item();

  /*!
   * End of iteration ?
   * @return \c true if the iteration has ended.
   */
  bool IsEnd() const;

private:
  TfwkUiCfg *_pConfig;
  bool _bUnused;
  POSITION _it;
  TfwkUiTestCfg *_pCur;
};



inline void 
TfwkUiCfgTestIt::Begin()
{
  _it = _pConfig->_mapTestCfg.GetStartPosition();
  Next();
}


inline TfwkUiTestCfg &
TfwkUiCfgTestIt::Item()
{
  ASSERT( _pCur );
  return *_pCur;
}


inline bool 
TfwkUiCfgTestIt::IsEnd() const
{
  return _pCur == NULL;
}

#endif // !defined(AFX_TFWKUICFGTESTIT_H__33520482_4266_11D3_BE2D_0040053AD648__INCLUDED_)
