// TfwkUiCfgWriter.h: interface for the TfwkUiCfgWriter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TFWKUICFGWRITER_H__EDB173B3_41EF_11D3_BE2B_0040053AD648__INCLUDED_)
#define AFX_TFWKUICFGWRITER_H__EDB173B3_41EF_11D3_BE2B_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class TfwkUiCfg;
class TfwkUiSuite;
class TfwkUiTest;

class TfwkUiCfgWriter  
{
public:
	TfwkUiCfgWriter( CFile &file,
                   TfwkUiCfg &config );
	virtual ~TfwkUiCfgWriter();

  void Save();

protected:
  void SaveSuite( TfwkUiSuite &suite );
  void SaveSuiteChildren( TfwkUiSuite &suite );
  void SaveTest( TfwkUiTest &test );
  void WriteLine( const CString &strLine = _T( "" ) );
  void WriteTag( const CString &strTagName );
  void WriteKey( const CString &strKeyName,
                 const CString &strKeyValue );

private:
  CArchive *_pArchive;
  TfwkUiCfg *_pConfig;
  int _nSuiteDepth;
};


inline void 
TfwkUiCfgWriter::WriteLine( const CString &strLine )
{
  CString str;
  ASSERT( _nSuiteDepth >= 0 );
  int nDepth = _nSuiteDepth;
  while ( nDepth-- )
    str += _T( "  " );
  str += strLine;
  str += _T( "\n" );
  _pArchive->WriteString( str );
}

#endif // !defined(AFX_TFWKUICFGWRITER_H__EDB173B3_41EF_11D3_BE2B_0040053AD648__INCLUDED_)
