// TfwkUiSuite.cpp: implementation of the TfwkUiSuite class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TfwkUi.h"
#include "TfwkUiSuite.h"
#include "TfwkUiTestSuiteReport.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TfwkUiSuite::TfwkUiSuite( TfwkUiSuite *pSuite,
                         const CString &strName ) :
    _pParentSuite( pSuite ),
    _strName( strName )
{
  if ( pSuite )
    pSuite->AddSuite( this );
}


TfwkUiSuite::~TfwkUiSuite()
{

}


void 
TfwkUiSuite::AddSuite( TfwkUiSuite *pSuite )
{
  _aSuite.add( pSuite );
}


void 
TfwkUiSuite::AddTest( TfwkUiTest *pTest )
{
  _aTest.add( pTest );
}


void 
TfwkUiSuite::RemoveSuite( TfwkUiSuite *pSuite )
{
  int nPos = _aSuite.find( pSuite );
  if ( nPos >= 0 )
  {
    _aSuite.remove( nPos );
  }
}


void 
TfwkUiSuite::RemoveTest( TfwkUiTest *pTest )
{
  int nPos = _aTest.find( pTest );
  if ( nPos >= 0 )
  {
    _aTest.remove( nPos );
  }
}


void 
TfwkUiSuite::Clear()
{
  _aSuite.clear();
  _aTest.clear();
}


void 
TfwkUiSuite::RunTest( TfwkUiCfg &cfg,
                      TfwkUiTestSuiteReport &report )
{
  SuiteIt itSuite = ItSuite();
  for ( itSuite.begin(); !itSuite.isEnd(); itSuite.next() )
  {
    itSuite.item()->RunTest( cfg, report );
  }

  TestIt itTest = ItTest();
  for ( itTest.begin(); !itTest.isEnd(); itTest.next() )
  {
    itTest.item()->RunTest( cfg, report );
  }
}

