// TfwkUiTestSuiteReport.h: interface for the TfwkUiTestSuiteReport class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TFWKUITESTSUITEREPORT_H__B8E11081_42D5_11D3_BE2F_0040053AD648__INCLUDED_)
#define AFX_TFWKUITESTSUITEREPORT_H__B8E11081_42D5_11D3_BE2F_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Tfwk.h"
class TfwkDlg;
class TfwkUiTest;

enum TfwkUiReportErrorType
{
  etpNone =0,
  etpError,
  etpFailure,
};


struct TfwkUiReportError
{
  TfwkUiReportErrorType _etpError;
  CString _strSource;
  int _nLine;
  CString _strDetail;
  TfwkUiTest *_pTest;
};

struct TfwkUiTestSuiteReport  
{
public:

  typedef TfwkArrayPtrT<TfwkUiReportError *> ErrorArray;
  typedef ErrorArray::TfwkConstIt ErrorIt;

  void ReportError( TfwkUiReportErrorType etpError, 
                    const CString &strSource,
                    int nLine,
                    const CString &strDetail,
                    TfwkUiTest *pTest );

	TfwkUiTestSuiteReport();
	~TfwkUiTestSuiteReport();

  void Reset();

  /*!
   * Number of uncatched exception.
   */
  int _nError;

  /*!
   * Number of assertion failed.
   */
  int _nFailure;

  /*!
   * Number of test that suceeded
   */
  int _nSuccess;

  /*!
   * Number of test that has been skipped (method does not exist)
   */
  int _nSkipped;

  /*!
   * Total number of test that has been runned (existed).
   */
  int _nTotal;

  /*!
   * Array of error.
   */
  ErrorArray *_paError;

  /*!
   * Pointer on the thing error are reported to.
   */
  TfwkDlg *_pDlg;
};

#endif // !defined(AFX_TFWKUITESTSUITEREPORT_H__B8E11081_42D5_11D3_BE2F_0040053AD648__INCLUDED_)
