// TfwkUiTreeViewSuite.cpp : implementation file
//

#include "stdafx.h"
#include "TfwkUi.h"
#include "TfwkUiTreeViewSuite.h"
#include "TfwkUiTreeSuiteItem.h"
#include "TfwkUiSuite.h"
#include "TfwkUiTest.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// TfwkUiTreeViewSuite

TfwkUiTreeViewSuite::TfwkUiTreeViewSuite()
{
}


TfwkUiTreeViewSuite::~TfwkUiTreeViewSuite()
{
}


BEGIN_MESSAGE_MAP(TfwkUiTreeViewSuite, CTreeCtrl)
	//{{AFX_MSG_MAP(TfwkUiTreeViewSuite)
	ON_WM_CONTEXTMENU()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// TfwkUiTreeViewSuite message handlers

void 
TfwkUiTreeViewSuite::OnContextMenu( CWnd* pWnd, 
                                    CPoint point ) 
{
  CMenu *pMenu;
  CPoint ptAction;
  
  ScreenToClient (&point );
  UINT uFlags;
  HTREEITEM hItem = HitTest( point, &uFlags );
  ClientToScreen( &point );

  ptAction = point;

  pMenu = _menuPopupTreeSuite.GetSubMenu( 0 );
  if ( hItem )   // no item selected
  {
    TfwkUiTreeSuiteItem *pItem = (TfwkUiTreeSuiteItem *)GetItemData( hItem );
    if ( pItem )
    {
      if ( pItem->IsSuite() )
        pMenu = _menuPopupTreeSuiteSuite.GetSubMenu( 0 );
      else if ( pItem->IsTest() )
        pMenu = _menuPopupTreeSuiteTest.GetSubMenu( 0 );
    }

    SelectItem( hItem );
  }

  CWnd* pWndPopupOwner = this;

  while (pWndPopupOwner->GetStyle() & WS_CHILD)
         pWndPopupOwner = pWndPopupOwner->GetParent();


  pMenu->TrackPopupMenu( TPM_CENTERALIGN | TPM_RIGHTBUTTON, 
                         ptAction.x, ptAction.y, 
                         pWndPopupOwner );
}


void 
TfwkUiTreeViewSuite::PreSubclassWindow() 
{
  VERIFY( _menuPopupTreeSuite.LoadMenu( IDR_TFWKUI_POPMENU_TREESUITE ) );
  VERIFY( _menuPopupTreeSuiteSuite.LoadMenu( IDR_TFWKUI_POPMENU_TREESUITE_SUITE ) );
  VERIFY( _menuPopupTreeSuiteTest.LoadMenu( IDR_TFWKUI_POPMENU_TREESUITE_TEST ) );
	
  VERIFY( _imlTree.Create( IDB_TFWKUI_TREESUITE, 16, 1, RGB( 255,0,255 ) ) );

  SetImageList( &_imlTree, TVSIL_NORMAL );

	CTreeCtrl::PreSubclassWindow();
}


HTREEITEM 
TfwkUiTreeViewSuite::AddSuite( TfwkUiSuite *pParentSuite,
                               HTREEITEM hParentItem,
                               TfwkUiSuite *pSuite,
                               bool bSort,
                               HTREEITEM *pNewItem )
{
  // Found the correct hParentItem
  hParentItem = GetParentSuite( hParentItem, pParentSuite );
  /*
  TfwkUiSuite *pItemSuite;
  do
  {
    if ( !hParentItem )
      break;

    pItemSuite = (TfwkUiSuite *)GetItemData( hParentItem );
    if ( pItemSuite->IsSuite() )
    {
      if ( pItemSuite == pParentSuite )   // found
        break;
    }

    hParentItem = GetParentItem( hParentItem );
  }
  while ( true );
*/
  LockWindowUpdate();

  int nImage = imgSuite;
  HTREEITEM hNewItem;
  VERIFY( hNewItem = InsertItem( pSuite->Name(),
                                 nImage,
                                 nImage,
                                 hParentItem ) );
  if ( hNewItem )
    SetItemData( hNewItem, (DWORD)pSuite );

  if ( pNewItem )
    *pNewItem = hNewItem;

  if ( bSort )
     VERIFY( SortChildren( hParentItem ) );

  UnlockWindowUpdate();
  UpdateWindow();

  return hParentItem;
}


void 
TfwkUiTreeViewSuite::DeleteSuite( HTREEITEM hItem )
{
  DeleteItem( hItem );
}


// Allows popup with a simple click & selects clicked item !
void 
TfwkUiTreeViewSuite::OnRButtonDown(UINT nFlags, CPoint point) 
{
  UINT uFlags;
  HTREEITEM hItem = HitTest(point, &uFlags);
  if ( hItem  && 
       (uFlags & TVHT_ONITEM) ) 
  {
    SelectItem( hItem );
  }
  else
  {
    SelectItem( NULL );
  }
}


HTREEITEM 
TfwkUiTreeViewSuite::GetParentSuite( HTREEITEM hItem,
                                     TfwkUiSuite *pParentSuite )
{
  TfwkUiSuite *pItemSuite;
  do
  {
    if ( !hItem )
      break;

    pItemSuite = (TfwkUiSuite *)GetItemData( hItem );
    if ( pItemSuite->IsSuite() )
    {
      if ( !pParentSuite  ||
           pItemSuite == pParentSuite )   // found
        break;
    }

    hItem = GetParentItem( hItem );
  }
  while ( true );
  return hItem;
}


void 
TfwkUiTreeViewSuite::AddTest( HTREEITEM hItem,
                              TfwkUiTest *pTest )
{
  hItem = GetParentSuite( hItem );

  int nImage = imgUnitTest;
  HTREEITEM hNewItem;
  CString strName;
  pTest->FullMethodName( strName );
  VERIFY( hNewItem = InsertItem( strName,
                                 nImage,
                                 nImage,
                                 hItem ) );
  if ( hNewItem )
    SetItemData( hNewItem, (DWORD)pTest );
}


void 
TfwkUiTreeViewSuite::UpdateSubTree( HTREEITEM hItem,
                                    TfwkUiSuite *pSuite,
                                    bool bHItemIsParent )
{
  HTREEITEM hParentItem;
  bool bWasExpanded =false;
  if ( !bHItemIsParent  &&  hItem != NULL )
  {
    bWasExpanded = (GetItemState( hItem, TVIS_EXPANDED ) & TVIS_EXPANDED) != 0;
    hParentItem= GetParentItem( hItem );
    DeleteItem( hItem );
  }
  else
    hParentItem = hItem;

  HTREEITEM hNewItem;
  if ( pSuite->ParentSuite() )
    AddSuite( pSuite->ParentSuite(), 
              hParentItem, 
              pSuite,
              false,
              &hNewItem );
  else
    hNewItem = NULL;

  TfwkUiSuite::SuiteIt itSuite = pSuite->ItSuite();
  for ( itSuite.begin(); !itSuite.isEnd(); itSuite.next() )
  {
    UpdateSubTree( hNewItem,
                   itSuite.item(), 
                   true );
  }

  TfwkUiSuite::TestIt itTest = pSuite->ItTest();
  for ( itTest.begin(); !itTest.isEnd(); itTest.next() )
  {
    AddTest( hNewItem,
             itTest.item() );
  }

  SortChildren( hNewItem );
}


void 
TfwkUiTreeViewSuite::RebuildTree( TfwkUiSuite &suiteRoot )
{
  LockWindowUpdate();
  
  DeleteAllItems();

  UpdateSubTree( NULL,
                 &suiteRoot,
                 false );

  UnlockWindowUpdate();
  UpdateWindow();
}
