#if !defined(AFX_TFWKUITREEVIEWSUITE_H__33520483_4266_11D3_BE2D_0040053AD648__INCLUDED_)
#define AFX_TFWKUITREEVIEWSUITE_H__33520483_4266_11D3_BE2D_0040053AD648__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// TfwkUiTreeViewSuite.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// TfwkUiTreeViewSuite window

#include "Resource.h"

class TfwkUiSuite;
class TfwkUiTest;

class TfwkUiTreeViewSuite : public CTreeCtrl
{
// Construction
public:
	TfwkUiTreeViewSuite();

  /*!
   * Gets the parent suite item.
   * @param hItem Item we want the parent suite.
   * @return Parent suite item.
   */
  HTREEITEM GetParentSuite( HTREEITEM hItem,
                            TfwkUiSuite *pParentSuite =NULL );

  /*!
   * Adds a suite to a suite.
   * @param pParentSuite [In] Pointer on the parent suite. Must not be \c NULL.
   * @param hParentItem [In] Item of the parent suite or one of its child.
   * @param pSuite [In] Pointer on the suite to add. Must not be \c NULL.
   * @param bSort [In] If \c true then item of the parent suite are sorted.
   * @param pNewItem [I/O] On return, if not \c NULL, new item.
   * @return Parent item.
   */
  HTREEITEM AddSuite( TfwkUiSuite *pParentSuite,
                      HTREEITEM hParentItem,
                      TfwkUiSuite *pSuite,
                      bool bSort =true,
                      HTREEITEM *pNewItem =NULL );

  /*!
   * Deletes a suite.
   * @param hItem [In] Item of the suite to remove.
   */
  void DeleteSuite( HTREEITEM hItem );

  /*!
   * Adds a test to a suite.
   * @param hItem [In] Item of the suite.
   * @param pTest [In] Pointer on the test to add. Must not be NULL.
   */
  void AddTest( HTREEITEM hItem,
                TfwkUiTest *pTest );

  /*!
   * Rebuilds a subtree.
   * @param hItem item of the parent of the subtree to rebuild.
   * @param pSuite Suite for the item of \a hItem.
   * @param bHItemIsParent Indicates that hItem is the parent item of \a pSuite and
   *                       that the item matching pSuite does not exist.
   */
  void UpdateSubTree( HTREEITEM hItem,
                      TfwkUiSuite *pSuite,
                      bool bHItemIsParent =false );

  /*!
   * Rebuild all the tree.
   * @param suiteRoot Reference on the root suite.
   */
  void RebuildTree( TfwkUiSuite &suiteRoot );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(TfwkUiTreeViewSuite)
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~TfwkUiTreeViewSuite();

	// Generated message map functions
protected:
	//{{AFX_MSG(TfwkUiTreeViewSuite)
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP();

private:
  enum
  {
    imgSuite =0,
    imgUnitTest,
  };


  CMenu _menuPopupTreeSuite;
  CMenu _menuPopupTreeSuiteSuite;
  CMenu _menuPopupTreeSuiteTest;
  CImageList _imlTree;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TFWKUITREEVIEWSUITE_H__33520483_4266_11D3_BE2D_0040053AD648__INCLUDED_)
