// ChildFrm.cpp : implementation of the CChildFrame class
//

/* History
- 13/01/98: Debut status bar. Comment faire pour du owner draw ou bien mettre
            une progresse bar dedans ?
 */


#include "stdafx.h"
#include "ttr.h"

#include "ChildFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Les indicateurs de la status bar.
// Note: Chaque indicator doit avoir une chaine correspondant a son ID dans la table
// des strings.
static UINT indicators[]= {
  IDI_LINE_CURRENT_NO,
  IDI_PROGRESS_BAR
};

/////////////////////////////////////////////////////////////////////////////
// CChildFrame

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CChildFrame)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChildFrame construction/destruction

CChildFrame::CChildFrame()
{
	// TODO: add member initialization code here
	
}

CChildFrame::~CChildFrame()
{
}

BOOL CChildFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CMDIChildWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CChildFrame diagnostics

#ifdef _DEBUG
void CChildFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void CChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChildFrame message handlers

int CChildFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

  if ( !m_statusBar.CreateStatusBar( this, 
                                     indicators, 
                                     sizeof(indicators)/sizeof(UINT) ) )
	{
		TRACE0("Failed to create status bar for MDI Child\n");
		return -1;      // fail to create
	}

  m_statusBar.SetPaneStyle( m_statusBar.CommandToIndex( IDI_LINE_CURRENT_NO ),
                            SBPS_NORMAL );
  m_statusBar.SetPaneStyle( m_statusBar.CommandToIndex( IDI_PROGRESS_BAR ),
                            SBPS_STRETCH );


  MDIMaximize();
	
	return 0;
}

void CChildFrame::SetCurrentLineNo(int no)
{
  m_currentLineNoText.Format( _T("Line: %d"), 
                              no );
  int nIdx = m_statusBar.CommandToIndex( IDI_LINE_CURRENT_NO );
  ASSERT( nIdx != -1 );
  m_statusBar.SetPaneText( nIdx, m_currentLineNoText );
}


void 
CChildFrame::onProgressStart()
{
  int nIdx = m_statusBar.CommandToIndex( IDI_PROGRESS_BAR );
  m_statusBar.SavePane( nIdx );
  m_statusBar.SetMode( nIdx, XSB_PROGRESS | XSB_SMOOTH | XSB_TEXT );
  m_statusBar.SetText( nIdx, taskName() );
  m_statusBar.SetRange( nIdx, minProgressValue(), maxProgressValue() );
  m_statusBar.SetPos( nIdx, progressValue() );
}

void 
CChildFrame::onProgress()
{
  int nIdx = m_statusBar.CommandToIndex( IDI_PROGRESS_BAR );
  m_statusBar.SetPos( nIdx, progressValue() );
  getApp().processMessages();
}

void 
CChildFrame::onProgressStop()
{
  int nIdx = m_statusBar.CommandToIndex( IDI_PROGRESS_BAR );
  m_statusBar.RestorePane( nIdx );
}
