#ifndef EBITMAP_H_INCLUDED
#define EBITMAP_H_INCLUDED

// Generic Transparent bitmap display class.
class CEBitmap
{
public:
  // aligment for the bitmap
  enum
  {
    posLeft =0,
    posTop = posLeft,
    posCenter,
    posRight,
    posBottom =posRight
  };

  // Constructs the bitmap
  CEBitmap();

  // Constructs the bitmap
  // nIdBitmap: Id ressource bitmap ( fond = blanc )
  // nIdBitmapMask: Id ressource mask bitmap (fond = blanc, mask = noir )
	CEBitmap( int nIdBitmap, 
            int nIdBitmapMask);

   ~CEBitmap();

  // Draw the bitmap on the DC.
  // dc: DC the bitmap is drawn on.
  // (x,y): position where the bitmap is drawn.
  // xPos: aligment of the bitmap relatively to (x,y).
  //         posLeft: x is the left border coordinate of the bitmap
  //         posCenter: x is the center coordinate of the bitmap
  //         posRight: x is the right border coordinate of the bitmap
  // yPos: aligment of the bitmap relatively to (x,y).
  //        posLeft: y is the top border coordinate of the bitmap
  //        posCenter: y is the center coordinate of the bitmap
  //        posRight: y is the top border coordinate of the bitmap
   void Draw( CDC& dc, 
              int x, int y, 
              int xPos =posCenter, int yPos =posCenter );

  // Load the bitmap & the mask bitmap
  // return TRUE on success.
	BOOL LoadBitmap( int nIdBitmap,
                   int nIdBitmapMask );

  // Return the Width of the bitmap  
	int GetWidth() const;

  // Return the Height of the bitmap
  int GetHeight() const;

private:
	void init();
	int ComputeAbsPos( int nPos, int nSize, int nAlignement )  const;
	int m_height;
	int m_width;
	BOOL m_bmLoaded;
	CBitmap m_bmMask;
	CBitmap m_bm;
};


inline int CEBitmap::GetWidth() const
{
  return m_width;
}

inline int CEBitmap::GetHeight() const
{
  return m_height;
}


#endif