// EwgClipboardManager.cpp: implementation of the EwgClipboardManager class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ttr.h"
#include "EwgClipboardManager.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

EwgClipboardManager::EwgClipboardManager()
{

}


EwgClipboardManager::~EwgClipboardManager()
{

}


bool 
EwgClipboardManager::readTextFromClipboard( EBuffer &buffer )
{
  if ( !::IsClipboardFormatAvailable( CF_TEXT ) )
    return false;

  bool bSuccess =false;
  
  if ( ::OpenClipboard( NULL ) )
  {
    HGLOBAL hData = ::GetClipboardData( CF_TEXT );
    if ( hData )
    {
      const char *cszText = (const char *)::GlobalLock( hData );
      if ( cszText )
      {
        buffer.writeBlock( cszText, ::strlen( cszText ) );
        ::GlobalUnlock( hData );
        bSuccess =true;
      }
    }

    ::CloseClipboard();
  }

  return bSuccess;
}


bool 
EwgClipboardManager::writeTextToClipboard( EBuffer &buffer )
{
  if ( !::OpenClipboard( NULL ) )
    return false;

  bool bSuccess = false;
  ::EmptyClipboard();
  SL nDataLen = buffer.size() - buffer.at();
  HGLOBAL hData = ::GlobalAlloc( GMEM_DDESHARE, nDataLen +1 );
  if ( hData )
  {
    char *szData = (char *)::GlobalLock( hData );
    if ( szData ) 
    {
      buffer.readBlock( szData, nDataLen );
      szData[ nDataLen ] = 0;

      ::GlobalUnlock( hData );
      ::SetClipboardData( CF_TEXT, hData );

      bSuccess = true;
    }
  }

  ::CloseClipboard();
  return bSuccess;
}
