// MainFrm.cpp : implementation of the CMainFrame class
//

/* History:
- 18/01/98: Add OnDropFiles() to manage open documents on dropped files.
*/
  

#include "stdafx.h"
#include "ttr.h"

#include "MainFrm.h"
#include "EDragFilelist.h"
#include "EwgDlgFindText.h"
#include "TtrView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_DROPFILES()
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CMDIFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CMDIFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CMDIFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CMDIFrameWnd::OnHelpFinder)
  ON_REGISTERED_MESSAGE( EwgDlgFindText_msgOnFind, OnFindText )
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

  if ( !m_wndStatusBar.CreateStatusBar( this, 
                                        indicators, 
                                        sizeof(indicators)/sizeof(UINT) ) )
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CMDIFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void 
CMainFrame::OnDropFiles(HDROP hDropInfo) 
{
  CEDragFileList fileList( hDropInfo );
  fileList.OpenDocuments( &theApp );
}


LONG 
CMainFrame::OnFindText( UINT dwInfo, 
                        LONG )
{
  EWGDLGFINDTEXT_MSGFINDTEXT;

  CMDIChildWnd *pWnd = MDIGetActive();
  if ( pWnd  &&  pWnd->IsKindOf( RUNTIME_CLASS( CChildFrame ) ) )
  {
    CTtrView *pView = ((CChildFrame *)pWnd)->GetView();
    pView->DoFindText( info );
  }

  return 1;
}


void 
CMainFrame::onProgressStart()
{
  int nIdx = m_wndStatusBar.CommandToIndex( ID_SEPARATOR );
  m_wndStatusBar.SavePane( nIdx );
  m_wndStatusBar.SetMode( nIdx, XSB_PROGRESS | XSB_SMOOTH | XSB_TEXT );
  m_wndStatusBar.SetText( nIdx, taskName() );
  m_wndStatusBar.SetRange( nIdx, minProgressValue(), maxProgressValue() );
  m_wndStatusBar.SetPos( nIdx, progressValue() );
}


void 
CMainFrame::onProgress()
{
  int nIdx = m_wndStatusBar.CommandToIndex( ID_SEPARATOR );
  m_wndStatusBar.SetPos( nIdx, progressValue() );
  getApp().processMessages();
}


void 
CMainFrame::onProgressStop()
{
  int nIdx = m_wndStatusBar.CommandToIndex( ID_SEPARATOR );
  m_wndStatusBar.RestorePane( nIdx );
}
