// TtrDlgEnclosure.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "TtrDlgEnclosure.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// TtrDlgEnclosure dialog


TtrDlgEnclosure::TtrDlgEnclosure( const TtrEnclosureList &listEnclosure,
                                 CWnd* pParent ) :
	CDialog(TtrDlgEnclosure::IDD, pParent)
{
	//{{AFX_DATA_INIT(TtrDlgEnclosure)
	_strClosure = _T("");
	_strOpening = _T("");
	//}}AFX_DATA_INIT

  _listEnclosure.addListener( this );
  _listEnclosure = listEnclosure;
}


void 
TtrDlgEnclosure::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(TtrDlgEnclosure)
	DDX_Control(pDX, IDC_LIST_ENCLOSURE, _lbEnclosure);
	DDX_Text(pDX, IDC_EDIT_CLOSURE, _strClosure);
	DDX_Text(pDX, IDC_EDIT_OPENING, _strOpening);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(TtrDlgEnclosure, CDialog)
	//{{AFX_MSG_MAP(TtrDlgEnclosure)
	ON_BN_CLICKED(IDC_ENCLOSURE_ADD, OnEnclosureAdd)
	ON_BN_CLICKED(IDC_ENCLOSURE_CHANGE, OnEnclosureChange)
	ON_BN_CLICKED(IDC_ENCLOSURE_REMOVE, OnEnclosureRemove)
	ON_LBN_SELCHANGE(IDC_LIST_ENCLOSURE, OnSelchangeListEnclosure)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// TtrDlgEnclosure message handlers


BOOL 
TtrDlgEnclosure::OnInitDialog() 
{
	CDialog::OnInitDialog();

  updateListBoxEnclosure();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void 
TtrDlgEnclosure::OnEnclosureAdd() 
{
  UpdateData();
  EString strOpen( (LPCTSTR)_strOpening );
  EString strClosure( (LPCTSTR)_strClosure );

  if ( strOpen.isNull()  ||  strClosure.isNull() )
    return;

  _listEnclosure.addEnclosure( new TtrEnclosure( strOpen, strClosure ) );
}


void 
TtrDlgEnclosure::OnEnclosureChange() 
{
  UpdateData();
  TtrEnclosure *pEnclosure = getSelectedEnclosure();
  if ( !pEnclosure )
    return;

  _listEnclosure.removeEnclosure( pEnclosure );
  _listEnclosure.addEnclosure( 
      new TtrEnclosure( (LPCTSTR)_strOpening, (LPCTSTR)_strClosure ) );
}


void 
TtrDlgEnclosure::OnEnclosureRemove() 
{
  TtrEnclosure *pEnclosure = getSelectedEnclosure();
  if ( !pEnclosure )
    return;

  _listEnclosure.removeEnclosure( pEnclosure );
}


const TtrEnclosureList &
TtrDlgEnclosure::getEnclosureList() const
{
  return _listEnclosure;
}


void 
TtrDlgEnclosure::updateListBoxEnclosure()
{
  if ( !_lbEnclosure.GetSafeHwnd() )
    return;

  _lbEnclosure.ResetContent();

  EAutoPtrT<ItTtrEnclosure> pIt = _listEnclosure.iterator();
  for ( pIt->begin(); !pIt->isEnd(); pIt->next() )
  {
    EString strText = pIt->item()->getOpening() + "  |  " + pIt->item()->getClosure();
    int nIdx = _lbEnclosure.AddString( (LPCTSTR)strText );
    if ( nIdx >= 0 )
      _lbEnclosure.SetItemDataPtr( nIdx, pIt->item() );
  }
}


void 
TtrDlgEnclosure::OnSelchangeListEnclosure() 
{
  refreshEditedEnclosure();	
}


void 
TtrDlgEnclosure::refreshEditedEnclosure()
{
  TtrEnclosure *pEnclosure = getSelectedEnclosure();
  if ( !pEnclosure )
    return;

  _strOpening = pEnclosure->getOpening();
  _strClosure = pEnclosure->getClosure();

  UpdateData( FALSE );
}


TtrEnclosure *
TtrDlgEnclosure::getSelectedEnclosure()
{
  if ( !_lbEnclosure.GetSafeHwnd() )
    return NULL;

  int nSel = _lbEnclosure.GetCurSel();
  if ( nSel < 0 )
    return NULL;

  TtrEnclosure *pEnclosure = (TtrEnclosure *)_lbEnclosure.GetItemDataPtr( nSel );
  return ( (int)pEnclosure == -1 ) ? NULL : pEnclosure;
}


void 
TtrDlgEnclosure::enclosureAdded( TtrEnclosureList &list, TtrEnclosure &enclosure )
{
  updateListBoxEnclosure();
}


void 
TtrDlgEnclosure::enclosureRemoved( TtrEnclosureList &list, TtrEnclosure *pEnclosure )
{
  updateListBoxEnclosure();
}


void 
TtrDlgEnclosure::enclosureListRenewed( TtrEnclosureList &list )
{
  updateListBoxEnclosure();
}
