// TtrEnclosureList.h: interface for the TtrEnclosureList class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TTRENCLOSURELIST_H__C0159B65_BE04_4862_919C_6FD382AF2D5E__INCLUDED_)
#define AFX_TTRENCLOSURELIST_H__C0159B65_BE04_4862_919C_6FD382AF2D5E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TtrEnclosure.h"
#include "TtrEnclosureListListener.h"

class TtrEnclosureListEvent;
class TtrEnclosureList;


class TtrEnclosureList  
{
public:
	TtrEnclosureList();
	TtrEnclosureList( const TtrEnclosureList &enclosureList );
	virtual ~TtrEnclosureList();

  /** Adds an enclosure to the list.
   * If the enclosure is already in the list (same opening & closure string), then
   * it is not added.
   * @param pEnclosure Pointer on the enclosure to add.
   */
  void addEnclosure( TtrEnclosure *pEnclosure );
  void removeEnclosure( TtrEnclosure *pEnclosure );

  void addListener( TtrEnclosureListListener *pListener );
  void removeListener( TtrEnclosureListListener *pListener );

  void clear();

  ItTtrEnclosure *iterator() const;

  TtrEnclosureList &operator =( const TtrEnclosureList &enclosureList );

private:
/** @supplierCardinality 0..**/
  TtrEnclosure * pTtrEnclosure;
/** @supplierCardinality 0..**/
  TtrEnclosureListListener * pTtrEnclosureListListener;
  void copy( const TtrEnclosureList &enclosureList );
  void fireRenewed();

  typedef EPtrDynArrayT<TtrEnclosure *> ArrayEnclosure;
  ArrayEnclosure _vpEnclosure;

  typedef EListenerList<TtrEnclosureListListener> ListenerList;
  ListenerList _listListener;
};

#endif // !defined(AFX_TTRENCLOSURELIST_H__C0159B65_BE04_4862_919C_6FD382AF2D5E__INCLUDED_)
