// TtrGlobalSetting.h: interface for the TtrGlobalSetting class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TTRGLOBALSETTING_H__42E8B431_91DC_11D1_91D7_895506BF7561__INCLUDED_)
#define AFX_TTRGLOBALSETTING_H__42E8B431_91DC_11D1_91D7_895506BF7561__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "usuel.hpp"
#include "estring.hpp"
#include "TtrFormatSetting.h"
#include "TtrWriterSetting.h"
#include "TtrEnclosureList.h"
#include "TtrGlobalSettingListener.h"

class TtrGlobalSettingListener;



class TtrGlobalSetting : public TtrWriterSetting, public TtrFormatSetting  
{
public:
	TtrGlobalSetting();
	~TtrGlobalSetting();

  void SetToDefault();

  void reset();

	static bool WordEOSValid( const CString& sWordEOS, 
                            const CString& sEOSChars );
	TtrGlobalSetting& operator =( const TtrGlobalSetting& mode );


  void addChangeListener( TtrGlobalSettingListener *pListener );
  void removeChangeListener( TtrGlobalSettingListener *pListener );
  void fireChanged();

  // Writer Setting Interface
  virtual void setWriterType( TtrWriterSettingType nWriterType );
  virtual TtrWriterSettingType getWriterType() const;

  virtual void setWriterLineMode( TtrWriterLineMode nWriterLineMode );
  virtual TtrWriterLineMode getWriterLineMode() const;

  virtual void setWriterReindentSize( UL nReindentSize );
  virtual UL getWriterReindentSize() const;
  
  virtual void setWriterJumpOneLine( bool bJumpOneLine );
  virtual bool getWriterJumpOneLine() const;

  virtual void setWriterRemoveEndingHyphen( bool bRemoveEndingHyphen );
  virtual bool getWriterRemoveEndingHyphen() const;

  // Format Setting Interface
  virtual void setFormatType( TtrFormatSettingType nType );
  virtual TtrFormatSettingType getFormatType() const;

  virtual void setFormatSeparatorChar( const EString &strSeparatorChar );
  virtual const EString &getFormatSeparatorChar() const;

  virtual void setFormatIndentBlankLine( bool bIndentBlankLine );
  virtual bool getFormatIndentBlankLine() const;
  
  virtual void setFormatModeEos( bool bModeEos );
  virtual bool getFormatModeEos() const;
  
  virtual void setFormatIndentIndentedLine( bool bIndentIndentedLine );
  virtual bool getFormatIndentIndentedLine() const;
  
  virtual void setFormatIndentPreviousLineIsBlank( bool bIndentPreviousLineIsBlank );
  virtual bool getFormatIndentPreviousLineIsBlank() const;
  
  virtual void setFormatIndentSeparator( bool bIndentSeparator );
  virtual bool getFormatIndentSeparator() const;
  
  virtual void setFormatIndentContainDoubleDot( bool bIndentContainDoubleDot );
  virtual bool getFormatIndentContainDoubleDot() const;
  
  virtual void setFormatIndentBeginWith( bool bIndentBeginWith );
  virtual bool getFormatIndentBeginWith() const;
  
  virtual void setFormatIndentBeginWithChar( const EString &strBeginWith );
  virtual const EString &getFormatIndentBeginWithChar() const;

  
  virtual void setFormatUseEnclosure( bool bUseEnclosure );
  virtual bool getFormatUseEnclosure() const;
  
  virtual void setFormatEnclosureList( const TtrEnclosureList &listEnclosure );
  virtual TtrEnclosureList &getFormatEnclosureList();
  virtual const TtrEnclosureList &getFormatEnclosureList() const;
  
  virtual void setFormatUseLeftMargin( bool bUseLeftMargin );
  virtual bool getFormatUseLeftMargin() const;
  
  virtual void setFormatLeftMargin( SL nLeftMargin );
  virtual SL getFormatLeftMargin() const;
  
  virtual void setFormatModeEosChar( const EString &strModeEosChar );
  virtual const EString &getFormatModeEosChar() const;
  
  virtual void setFormatUseRightMargin( bool bUseRightMargin );
  virtual bool getFormatUseRightMargin() const;
  
  virtual void setFormatRightMargin( SL nRightMargin );
  virtual SL getFormatRightMargin() const;

  virtual void setFormatNotLowerCaseLine( bool bNotLowerCaseLine );
  virtual bool getFormatNotLowerCaseLine() const;

  // EOS parameter
	CStringArray m_lsWordEOS;

private:
/** @supplierCardinality 0..**/
  TtrGlobalSettingListener * pTtrGlobalSettingListener;
  typedef EListenerList<TtrGlobalSettingListener> ChangeListenerList;
  ChangeListenerList _listChangeListener;

  // Writer settings
  TtrWriterSettingType _nWriterType;
  TtrWriterLineMode _nWriterLineMode;
  UL _nWriterReindentSize;
  bool _bWriterJumpOneLine;
  bool _bWriterRemoveEndingHyphen;

  // Format settings
  TtrFormatSettingType _nFormatType;
  TtrEnclosureList _listFormatEnclosure;
  EString _strFormatSeparatorChar;
  EString _strFormatBeginWith;
  EString _strFormatModeEosChar;
  SL _nFormatLeftMargin;
  SL _nFormatRightMargin;
  bool _bFormatIndentBlankLine;
  bool _bFormatModeEos;
  bool _bFormatIndentIndentedLine;
  bool _bFormatIndentPreviousLineIsBlank;
  bool _bFormatIndentSeparator;
  bool _bFormatIndentContainDoubleDot;
  bool _bFormatIndentBeginWith;
  bool _bFormatUseEnclosure;
  bool _bFormatUseLeftMargin;
  bool _bFormatUseRightMargin;
  bool _bFormatNotLowerCaseLine;
};





#endif // !defined(AFX_TTRGLOBALSETTING_H__42E8B431_91DC_11D1_91D7_895506BF7561__INCLUDED_)
