// Generated by Together

#include "StdAfx.h"
#include "TtrText.h"
#include "TtrTextLine.h"
#include "EwgFindTextInfo.h"
#include "TtrTextModifiedTarget.h"

struct TtrTextForEachFnGlue : public TtrText::TtrTextForEachFn
{
  virtual void operator ()( TtrTextLine &line, SL nLineBlock )
  {
    line.setIndentLevel( -1 );
  }
};


struct TtrTextForEachFnReset : public TtrText::TtrTextForEachFn
{
  virtual void operator ()( TtrTextLine &line, SL nLineBlock )
  {
    line.setIndentLevel( 0 );
  }
};


struct TtrTextForEachFnIndent : public TtrText::TtrTextForEachFn
{
  virtual void operator ()( TtrTextLine &line, SL nLineBlock )
  {
    line.setIndentLevel( 1 );
  }
};




TtrText::TtrText() :
    _nMaxLineLength( 0 ),
    _pTargetModified( NULL )
{
}


TtrText::~TtrText()
{
}


void 
TtrText::insertLine( TtrTextLine *pLine,
                     SL nLineNo )
{
  _nMaxLineLength = EMAX( _nMaxLineLength, pLine->length() );
  doInsertLine( pLine, nLineNo );
}


void 
TtrText::deleteLine( SL nLineNo )
{
  doDeleteLine( nLineNo );
}

 
void 
TtrText::indentBlock( const TtrTextBlockDef &defBlock )
{
  TtrTextForEachFnIndent fn;
  forEach( defBlock, fn );
}


void 
TtrText::glueBlock( const TtrTextBlockDef &defBlock )
{
  TtrTextForEachFnGlue fn;
  forEach( defBlock, fn );
}


void 
TtrText::restoreBlock( const TtrTextBlockDef &defBlock )
{
  TtrTextForEachFnReset fn;
  forEach( defBlock, fn );
}


void 
TtrText::setModified( bool bModified )
{
  if ( _pTargetModified )
    _pTargetModified->textModified( bModified );
}


void 
TtrText::forEach( const TtrTextBlockDef &defBlockIn, 
                  TtrTextForEachFn &fn )
{
  SL nLine;    
  TtrTextBlockDef defBlock( defBlockIn );

  if ( !defBlock.bound( nbLine() ) )
    return;

  SL nLineBlock =0;

  for ( nLine = defBlock.firstLine() ; 
        nLine <= defBlock.lastLine(); 
        ++nLine, ++nLineBlock )
  {
    fn( line(nLine), nLineBlock );
  }

  setModified();
}


SL 
TtrText::findString( SL nStartLineNo,
                     const EwgFindTextInfo &info )
{
  EString strToFind = info._strText;

  if ( !info._bMatchCase )
    strToFind.toLower();

  SL nNbLine = nbLine();
  SL nLineNo;
  
  if ( nStartLineNo < nbLine() )
  {
    if ( nStartLineNo )
      ++nStartLineNo;
  }

  for ( nLineNo = nStartLineNo; nLineNo < nNbLine; ++nLineNo )
  {
    const TtrTextLine &lineCur = line( nLineNo );

    if ( lineMatchSearchCriteria( lineCur, info, strToFind ) )
      return nLineNo;
  }

  return -1;
}


bool 
TtrText::lineMatchSearchCriteria( const TtrTextLine &line,
                                  const EwgFindTextInfo &info,
                                  const EString &strToFind )
{
  EString strLine;

  if ( !info._bMatchCase )    // copy string in lower case if case insensitive match
    strLine = line.lower();
  else
    strLine = line;

  SL nPosStart =0;
  bool bSucceed = false;
  do
  {
    SL nPos = strLine.pos( nPosStart, strToFind );
    if ( nPos == -1 )                           // string not found !
      break;

    SL nPosStart = nPos +1;

    bSucceed = true;

    if ( info._bMatchWholeWord )    // check that is a word
    {
      // check char before !
      if ( nPos )
      {
        TCHAR tcBefore = strLine.at( nPos -1 );
        if ( ( tcBefore >= 'a'  &&  tcBefore <= 'z' )  ||
             ( tcBefore >= '0'  &&  tcBefore <= '1' ) )
        
        {
          bSucceed = false;    // failed
        }
      }


      // check char after
      if ( bSucceed )
      {
        SL nPosNext = nPos + strToFind.length();
        if ( nPosNext < strLine.length() )
        {
          TCHAR tcAfter = strLine.at( nPosNext );
          if ( ( tcAfter >= 'a'  &&  tcAfter <= 'z' )  ||
               ( tcAfter >= '0'  &&  tcAfter <= '1' ) )
        
          {
            break;    // failed
          }
        }
      }
    }
  }
  while ( !bSucceed );

  return bSucceed;
}


const EString &
TtrText::getName() const
{
  return _strName;
}


void 
TtrText::setName( const EString &strName )
{
  _strName = strName;
}
