// TtrTextCoreInfo.h: interface for the TtrTextCoreInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TTRTEXTCOREINFO_H__D8EAC7BB_4E07_451F_B964_FA462344147D__INCLUDED_)
#define AFX_TTRTEXTCOREINFO_H__D8EAC7BB_4E07_451F_B964_FA462344147D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

typedef UL TtrTextCoreInfoId;

class TtrTextCoreInfo;

typedef EBinDynArrayT<TtrTextCoreInfo *> TtrTextCoreInfoList;

/** \brief Class that represents the core information about a text document.
 */
class TtrTextCoreInfo  
{
public:
  static const TtrTextCoreInfoId nullId;

	TtrTextCoreInfo( const TtrTextCoreInfo &info );
  TtrTextCoreInfo( const EString &strName );
	virtual ~TtrTextCoreInfo();

  const EString &getName() const;
  TtrTextCoreInfoId getCompositeParentId() const;
  void setCompositeParentId( TtrTextCoreInfoId nIdParent );
  TtrTextCoreInfoId getId() const;

  TtrTextCoreInfo &operator =( const TtrTextCoreInfo &info );
private:
  static TtrTextCoreInfoId _nNextId;
  TtrTextCoreInfoId _nId;
  EString _strName;
  TtrTextCoreInfoId _nIdCompositeParent;
};



// Inlines TtrTextCoreInfo:
// ------------------------
inline const EString &
TtrTextCoreInfo::getName() const
{
  return _strName;
}


inline TtrTextCoreInfoId 
TtrTextCoreInfo::getCompositeParentId() const
{
  return _nIdCompositeParent;
}


inline void 
TtrTextCoreInfo::setCompositeParentId( TtrTextCoreInfoId nIdParent )
{
  _nIdCompositeParent = nIdParent;
}


inline TtrTextCoreInfoId 
TtrTextCoreInfo::getId() const
{
  return _nId;
}


#endif // !defined(AFX_TTRTEXTCOREINFO_H__D8EAC7BB_4E07_451F_B964_FA462344147D__INCLUDED_)
