// Generated by Together

#ifndef TTRTEXTWRITERBUILDER_H
#define TTRTEXTWRITERBUILDER_H


class TtrWriterSetting;

/** Generic builder to write text that is composed of:
  * - separator
  * - paragraph
  * - blank line*/
class TtrTextWriterBuilder {
public:                 
  TtrTextWriterBuilder();
  virtual ~TtrTextWriterBuilder() {};

  void setStream( ETextStream &s );

/** Called at the beginning of the writing.*/
  virtual void buildStart( const TtrWriterSetting &setting ) {}

/** Called at the end of the writing.*/
  virtual void buildEnd( const TtrWriterSetting &setting ) {}          

  /** Called to write a paragraph that must be with the original 
  * indentation (unchanged).*/
  virtual void buildOriginal( const EString &strOriginal ) {}

/** Called to write a line that has is a separator.*/
  virtual void buildSeparator( const EString &strSep ) {}

/** Called to write one or more blank line.*/
  virtual void buildBlankBlock( SL nNbLine ) {}    
  
/** Called to write a new paragraph.*/
  virtual void buildParagraph( const EString &strCurrentOrigIndent, 
                               const EString &strPara ) {}

protected:
  ETextStream &stream();

private:
  ETextStream *_pstream;
};


inline 
TtrTextWriterBuilder::TtrTextWriterBuilder() :
    _pstream( NULL )
{
}


inline void 
TtrTextWriterBuilder::setStream( ETextStream &s )
{
  _pstream = &s;
}



inline ETextStream &
TtrTextWriterBuilder::stream()
{
  EASSERT( _pstream );
  return *_pstream;
}


#endif //TTRTEXTWRITERBUILDER_H







