// Generated by Together

#include "StdAfx.h"
#include "TtrTextWriterBuilderTxt.h"
#include "TtrWriterSetting.h"


void 
TtrTextWriterBuilderTxt::buildStart( const TtrWriterSetting &setting )
{
  EASSERT( setting.getWriterType() == wstpV0 );
  _pSetting = &setting;

  _astrStartPara.setNull();

  if ( _pSetting->getWriterJumpOneLine() )
    _astrStartPara += stream().getEol();

  if ( _pSetting->getWriterLineMode() != wslmIndentAsOriginal )
  {
    SL nCount;
    bool bUseTab = _pSetting->getWriterLineMode() == wslmIndentWithTab;
    for ( nCount =0; nCount < (SL)_pSetting->getWriterReindentSize(); ++nCount )
    {
      _astrStartPara += bUseTab ? '\t' : ' ';
    }
  }
}


void 
TtrTextWriterBuilderTxt::buildEnd( const TtrWriterSetting &setting )
{
}

          
void 
TtrTextWriterBuilderTxt::buildSeparator( const EString &strSep )
{
  if ( _pSetting->getWriterJumpOneLine() )
    stream()  <<  endl;
  stream().writeLine( strSep );
}


void 
TtrTextWriterBuilderTxt::buildParagraph( const EString &strOriginalIndentation,
                                          const EString &strPara )
{
  if ( _pSetting->getWriterLineMode() == wslmIndentAsOriginal )
    stream() << strOriginalIndentation;
  else
    stream()  <<  _astrStartPara;
  stream().writeLine( strPara );
}


void 
TtrTextWriterBuilderTxt::buildBlankBlock( SL nNbLine )
{
  while ( nNbLine-- )
    stream()  <<  endl;
}


void
TtrTextWriterBuilderTxt::buildOriginal( const EString &strOriginal )
{
  stream().writeLine( strOriginal );
}