// Generated by Together

#include "StdAfx.h"
#include "TtrTextWriter.h"
#include "TtrTextWriterBuilder.h"
#include "TtrTextWriterDirector.h"
#include "TtrWriterSetting.h"
#include "TtrFormatSetting.h"

TtrTextWriterDirector::TtrTextWriterDirector() :
  _pBuilder( NULL )
{
}


void 
TtrTextWriterDirector::setBuilder( TtrTextWriterBuilder &builder )
{
  _pBuilder = &builder;
}



void 
TtrTextWriterDirector::flushState()
{
  switch ( _state )
  {
  case stateBlankBlock:
    builder().buildBlankBlock( _nNbBlankLine );
    _nNbBlankLine =0;
    break;
  case stateParagraph:
    builder().buildParagraph( _strCurrentOrigIndent, _strCurrent );
    _strCurrent.setNull();
    break;
  case stateOriginal:
    builder().buildOriginal( _strCurrent );
    _strCurrent.setNull();
    break;
  case stateNone:
    return;
  default:
    EASSERT( FALSE );
  }

  _state = stateNone;
}


void 
TtrTextWriterDirector::writeText( TtrWriterSetting &setting, 
                                   TtrFormatSetting &settingFormat, 
                                   TtrText &text,           
                                   ETextStream &s,
                                   EwgProgressInfo &progress )
{
  EASSERT( _pBuilder );
  TtrTextWriterBuilder &builder = *_pBuilder;
  builder.setStream( s );

  EASSERT( setting.getWriterType() == wstpV0 );

  progress.setProgressRange( 0, text.nbLine() );
  progress.startProgress();

  builder.buildStart( setting );

  SL nLineNo;
  _nNbBlankLine =0;
  _nIndentLevel =0;
  _state = stateNone;
  _strCurrent.setNull();
  EString strTmp;
  for ( nLineNo =0; nLineNo < text.nbLine(); ++nLineNo )
  {
    const TtrTextLine &line = text.line( nLineNo );

    if ( line.indentLevel() < 0 )
    {
      if ( _state == stateNone )
      {
        _state = stateParagraph;
        _nIndentLevel = 1;
        _strCurrent = line;
        _strCurrent.trimSpaces();
        _strCurrentOrigIndent = line.left( line.countHeadingSpace() );
      }
      else
      {
        _strCurrent += _T( ' ' );
        strTmp = line;
        strTmp.trimSpaces();
        _strCurrent += strTmp;
      }
    }
    else if ( line.isBlank() )
    {
      if ( _state != stateBlankBlock )
      {
        flushState();
        _state = stateBlankBlock;
        _nNbBlankLine = 1;
      }
      else
        ++_nNbBlankLine;
    }
    else if ( line.isSeparatorLine( settingFormat.getFormatSeparatorChar() )  &&  
              line.indentLevel() > 0)
    {
      flushState();
      strTmp = line;
      strTmp.trimSpaces();
      builder.buildSeparator( strTmp );
    }
    else if ( line.indentLevel() > 0 )
    {
      flushState();
      _nIndentLevel = line.indentLevel();
      _state = stateParagraph;
      _strCurrent = line;
      _strCurrent.trimSpaces();
      _strCurrentOrigIndent = line.left( line.countHeadingSpace() );
    }
    else if ( line.indentLevel() == 0 )
    {
      flushState();
      _nIndentLevel = line.indentLevel();
      _state = stateOriginal;
      _strCurrent = line;
      _strCurrent.trimRight();
      _strCurrentOrigIndent = line.left( line.countHeadingSpace() );
    }

    if ( (nLineNo & 63) == 0 )
      progress.setProgressValue( nLineNo );
  }
 
  flushState();

  builder.buildEnd( setting );

  progress.stopProgress();
}


