// TtrTextWriterDirectorFsmState.h: interface for the TtrTextWriterDirectorFsmState class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TTRTEXTWRITTERDIRECTORFSMSTATE_H__027AC0E7_8557_4BEE_82CA_F26573BE334E__INCLUDED_)
#define AFX_TTRTEXTWRITTERDIRECTORFSMSTATE_H__027AC0E7_8557_4BEE_82CA_F26573BE334E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TtrTextWriterDirectorFsm.h"

// ////////////////////////////////////////////////////////////////////
// TtrTextWriterDirectorFsmState
// ////////////////////////////////////////////////////////////////////
class TtrTextWriterDirectorFsmState
{
public:
  TtrTextWriterDirectorFsmState() {}
  virtual ~TtrTextWriterDirectorFsmState() {}

  virtual void enterState( TtrTextWriterDirectorFsm &fsm ) {}
  virtual void exitState( TtrTextWriterDirectorFsm &fsm ) {}

  virtual void lineIsBlank( TtrTextWriterDirectorFsm &fsm ) {}
  virtual void lineIsIndented( TtrTextWriterDirectorFsm &fsm ) {}
  virtual void lineIsGlued( TtrTextWriterDirectorFsm &fsm ) {}
  virtual void lineIsOriginal( TtrTextWriterDirectorFsm &fsm ) {}
  virtual void lineIsSeparator( TtrTextWriterDirectorFsm &fsm ) {}
  virtual void endOfText( TtrTextWriterDirectorFsm &fsm ) {}

protected:
  void changeState( TtrTextWriterDirectorFsm &fsm,
                    TtrTextWriterDirectorFsmState &state );
};




// ////////////////////////////////////////////////////////////////////
// TtrTextWriterDirectorFsmStateInitial
// ////////////////////////////////////////////////////////////////////
class TtrTextWriterDirectorFsmStateInitial : public TtrTextWriterDirectorFsmState
{
public:
  TtrTextWriterDirectorFsmStateInitial() {}
  virtual ~TtrTextWriterDirectorFsmStateInitial() {}

  static TtrTextWriterDirectorFsmStateInitial &instance();

  virtual void lineIsBlank( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsIndented( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsGlued( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsOriginal( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsSeparator( TtrTextWriterDirectorFsm &fsm );
  virtual void endOfText( TtrTextWriterDirectorFsm &fsm );
};




// ////////////////////////////////////////////////////////////////////
// TtrTextWriterDirectorFsmStateBlankBlock
// ////////////////////////////////////////////////////////////////////
class TtrTextWriterDirectorFsmStateBlankBlock : public TtrTextWriterDirectorFsmState
{
public:
  TtrTextWriterDirectorFsmStateBlankBlock() {}
  virtual ~TtrTextWriterDirectorFsmStateBlankBlock() {}

  static TtrTextWriterDirectorFsmStateBlankBlock &instance();

  virtual void enterState( TtrTextWriterDirectorFsm &fsm );
  virtual void exitState( TtrTextWriterDirectorFsm &fsm );

  virtual void lineIsBlank( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsIndented( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsGlued( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsOriginal( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsSeparator( TtrTextWriterDirectorFsm &fsm );
  virtual void endOfText( TtrTextWriterDirectorFsm &fsm );

private:
  SL _nBlankLineCount;
};




// ////////////////////////////////////////////////////////////////////
// TtrTextWriterDirectorFsmStateParagraph
// ////////////////////////////////////////////////////////////////////
class TtrTextWriterDirectorFsmStateParagraph : public TtrTextWriterDirectorFsmState
{
public:
  TtrTextWriterDirectorFsmStateParagraph() {}
  virtual ~TtrTextWriterDirectorFsmStateParagraph() {}

  static TtrTextWriterDirectorFsmStateParagraph &instance();

  virtual void enterState( TtrTextWriterDirectorFsm &fsm );
  virtual void exitState( TtrTextWriterDirectorFsm &fsm );

  virtual void lineIsBlank( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsIndented( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsGlued( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsOriginal( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsSeparator( TtrTextWriterDirectorFsm &fsm );
  virtual void endOfText( TtrTextWriterDirectorFsm &fsm );

private:
  enum ParaType
  {
    ptpIndented,
    ptpOriginal
  } _nParaType;

  EString _strParagraph;
  EString _strOriginal;
};




// ////////////////////////////////////////////////////////////////////
// TtrTextWriterDirectorFsmStateSeparator
// ////////////////////////////////////////////////////////////////////
class TtrTextWriterDirectorFsmStateSeparator : public TtrTextWriterDirectorFsmState
{
public:
  TtrTextWriterDirectorFsmStateSeparator() {}
  virtual ~TtrTextWriterDirectorFsmStateSeparator() {}

  static TtrTextWriterDirectorFsmStateSeparator &instance();

  virtual void enterState( TtrTextWriterDirectorFsm &fsm );
  virtual void exitState( TtrTextWriterDirectorFsm &fsm );

  virtual void lineIsBlank( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsIndented( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsGlued( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsOriginal( TtrTextWriterDirectorFsm &fsm );
  virtual void lineIsSeparator( TtrTextWriterDirectorFsm &fsm );
  virtual void endOfText( TtrTextWriterDirectorFsm &fsm );
};



// implemention of TtrTextWriterDirectorFsmState
// ////////////////////////////////////////////////////////////////////
inline void 
TtrTextWriterDirectorFsmState::changeState( TtrTextWriterDirectorFsm &fsm,
                                             TtrTextWriterDirectorFsmState &state )
{
  fsm.changeState( state );
}


#endif // !defined(AFX_TTRTEXTWRITTERDIRECTORFSMSTATE_H__027AC0E7_8557_4BEE_82CA_F26573BE334E__INCLUDED_)
