// ttr.cpp : Defines the class behaviors for the application.
//

// - Rien compris au range autoris pour les messages users.
//   -> WM_USER utilis par bouton... WM_APP suppos libre mais indiqu comme
//      rserv pour windows. Contradiction dans l'aide ?
// - Comment faire pour envoy un message asynchrone avec une structure de donne
//   en paramtre ( ->comment la librer ? )

#include "stdafx.h"
#include "ttr.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "ttrDoc.h"
#include "ttrView.h"
#include "DlgModes.h"
#include "TtrGlobalSettingAccess.h"

#include "TtrTextReaderFactory.h"
#include "TtrTextReader.h"
#include "EwgClipboardManager.h"

#ifdef TFWK_USE
#  include <Tfwkui.h>
#endif

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
//         User Message ID
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

extern UINT NEAR MSG_GLOBAL_MODE_CHANGE = ::RegisterWindowMessage( _T("TTR::GlobalModeChange") );


/////////////////////////////////////////////////////////////////////////////
// CTtrApp

BEGIN_MESSAGE_MAP(CTtrApp, CWinApp)
	//{{AFX_MSG_MAP(CTtrApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_SET_GLOBAL_ANALYSIS_MODE, OnSetGlobalAnalysisMode)
	ON_COMMAND(ID_TTR_SEARCH_AGAIN, OnTtrSearchAgain)
	ON_COMMAND(ID_TFWK_UI_SHOW, OnTfwkUiShow)
	ON_COMMAND(ID_TTR_PASTE_NEW_DOCUMENT, OnTtrPasteNewDocument)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTtrApp construction

CTtrApp::CTtrApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
  m_dcScreen.Attach( ::GetDC( NULL ) );

  _pGlobalSetting = new TtrGlobalSetting();
  TtrGlobalSettingAccess::setGlobalSetting( _pGlobalSetting );

  m_pReformatTmpl = NULL;
}


CTtrApp::~CTtrApp()
{
  delete _pGlobalSetting;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTtrApp object

CTtrApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CTtrApp initialization

BOOL CTtrApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings(9);  // Load standard INI file options (including MRU)

  // should add setting load/save:
  TtrGlobalSettingAccess::getGlobalSetting().SetToDefault();

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_TTRTYPE,
		RUNTIME_CLASS(CTtrDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CTtrView));
  m_pReformatTmpl = pDocTemplate;
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
  
	// Dispatch commands specified on the command line
  if ( cmdInfo.m_nShellCommand != CCommandLineInfo::FileNew )   // prevent creation
  {                                                             // of an empty doc.
	  if (!ProcessShellCommand(cmdInfo))
		  return FALSE;
  }

#ifdef TFWK_USE
//  tfwkUiRunAllTest();
//  tfwkUiRunSuite( "Reformatter" );
//  tfwkUiRunSuite( "Writer" );
#endif	

//  testComposite();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CTtrApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CTtrApp commands

void 
CTtrApp::OnSetGlobalAnalysisMode() 
{
  CDlgModes dlg( IDS_DLG_CAPTION_GLOBAL_SETTING );
  dlg.SetMode( TtrGlobalSettingAccess::getGlobalSetting() );
  if ( dlg.DoModal() == IDOK )
  {
    dlg.GetMode( TtrGlobalSettingAccess::getGlobalSetting() );
    TtrGlobalSettingAccess::getGlobalSetting().fireChanged();
  }
}


void 
CTtrApp::showFindTextDlg()
{
  CWnd *pWnd = CWnd::GetActiveWindow();

  if ( !_dlgFindText.GetSafeHwnd() )    // not yet created !
    _dlgFindText.Create();

  if ( _dlgFindText.GetSafeHwnd() )     // show the find dialog & give it the focus.
  {
    if ( !_dlgFindText.IsWindowVisible() )    // center window relative to 
    {                                         // the active window
      _dlgFindText.ShowWindow( SW_SHOW );

      if ( !pWnd )
        pWnd = m_pMainWnd;

      if ( pWnd )
      {
        CRect rectWnd;
        pWnd->GetWindowRect( rectWnd );
        CRect rectDlg;
        _dlgFindText.GetWindowRect( rectDlg );
        CSize sizeOffset = rectWnd.Size() - rectDlg.Size();

        CPoint pointDlg( rectWnd.left + sizeOffset.cx /2,
                         rectWnd.top + sizeOffset.cy /2 );
        _dlgFindText.MoveWindow( CRect( pointDlg, rectDlg.Size() ) );
      }
    }

    SetActiveWindow( _dlgFindText );
    _dlgFindText.SetDefaultFocus();
  }
}


void 
CTtrApp::OnTtrSearchAgain() 
{
  if ( !_dlgFindText.SearchAgain() )      
  {
    MessageBeep( MB_ICONEXCLAMATION );
  }
}


BOOL
CTtrApp::processMessages()
{
	static MSG msg;

	while (::PeekMessage(&msg,NULL,0,0,PM_NOREMOVE)) {
		if (!AfxGetApp()->PumpMessage()) {
			::PostQuitMessage(0);
			return FALSE;
		}	
	}
  return TRUE;
}


void 
CTtrApp::OnTfwkUiShow() 
{
#ifdef TFWK_USE
  tfwkUiShow();	
#endif
}


int 
CTtrApp::ExitInstance() 
{
#ifdef TFWK_USE
  tfwkUiQuit();
#endif	
	return CWinApp::ExitInstance();
}


void 
CTtrApp::AddToRecentFileList(LPCTSTR lpszPathName) 
{
	
	CWinApp::AddToRecentFileList(lpszPathName);
}

#include "TtrTextCoreInfo.h"
#include "TtrDlgTextComposite.h"
void 
CTtrApp::testComposite()
{
  EString strBaseName = "G:\\tmp\\composite\\bgc.tokimemo.illusions.";
  TtrTextCoreInfoList listCoreInfo;
  for ( int nNo =1; nNo <= 19; nNo++ )
  {
    EString strFilename;
    strFilename.format( "%s%d", (const char *)strBaseName, nNo );
    listCoreInfo.append( new TtrTextCoreInfo( strFilename ) );
  }

  TtrDlgTextComposite dlg;
  dlg.setCoreInfoList( listCoreInfo );
  dlg.DoModal();
}


void 
CTtrApp::OnTtrPasteNewDocument() 
{
  EBuffer buffer;
  ETRY
  {

    CMainFrame *pMainFrame = (CMainFrame *)AfxGetApp()->m_pMainWnd;

    EwgClipboardManager clipboard;
    buffer.open( EIO_ReadWrite );
    if ( !clipboard.readTextFromClipboard( buffer ) )
    {
      AfxMessageBox( "Failed to paste text from clipboard!" );
      return;
    }

    CTtrDoc *pDoc = (CTtrDoc *)m_pReformatTmpl->CreateNewDocument();
    CFrameWnd *pFrame = m_pReformatTmpl->CreateNewFrame( pDoc, NULL );	
    if ( !pDoc  ||  !pFrame )    // Failed to create document!
      return;

    TtrTextReaderFactory factory;
    EAutoPtrT<TtrTextReader> ptrReader( 
        factory.createTextReader( "", TtrTextReaderFactory::trtpTxt ) );

    buffer.at( 0 );
    EDataStream sText( &buffer );
    TtrText *pText = ptrReader->readText( sText, *pMainFrame );
    pText->setName( "" );
    pText->setModifiedTarget( pDoc );
    pDoc->setText( pText );

    POSITION posView = pDoc->GetFirstViewPosition();
    CView *pView = pDoc->GetNextView( posView );
    if ( pView )
      pFrame->SetActiveView( pView );
  }
  ECATCH_IGNORE( EXCIODevice );
}
